!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine qqb_dm_monojet(p,msq) 
      implicit none
      include 'src/Inc/types.f'
       
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/cplx.h'
      include 'src/Inc/dm_params.f'
      include 'src/Inc/qcdcouple.f'
      real(dp):: p(mxpart,4),msq(-nf:nf,-nf:nf)
      complex(dp):: qqbg(2,2,2,2),qbqg(2,2,2,2)
      complex(dp):: qgqb(2,2,2,2),qbgq(2,2,2,2)
      complex(dp):: gqqb(2,2,2,2),gqbq(2,2,2,2)
      real(dp):: qqbg_sum(nf),qbqg_sum(nf)
      real(dp):: qgqb_sum(nf),qbgq_sum(nf)
      real(dp):: gqbq_sum(nf),gqqb_sum(nf)
      real(dp):: fac 
      integer:: j,k
      integer:: h2,h3,h4
      complex(dp):: cprop
      real(dp):: propsq
      real(dp):: s34 
!      logical:: check_QED 
!      common/check_QED/check_QED 

!      check_QED=.false. 

!      if(check_QED) then 
!------ make factor into photon propogator for testing 
!         s34=2d0*(p(3,4)*p(4,4)-p(3,3)*p(4,3)
!     &        -p(3,2)*p(4,2)-p(3,1)*p(4,1))
!         fac=gsq*V*esq**2/s34**2*4d0
!         do j=1,nf 
!            dmL(j)=Q(j)
!            dmR(j)=Q(j) 
!         enddo
!      else
!         fac=4d0/dm_lam**4*gsq*V
!      endif

!------ Fix Med-width 
!      if((medwidth==1d0).and.(first)) then 
!         medwidth=medmass/8d0/pi 
!        elseif((medwidth==0d0).and.(first)) then
!       medwidth=medmass/3d0
!      endif
!      if(first.and.(effective_th.eqv..false.)) then 
!     write(6,*) 'automatically set medwidth ',medwidth 
!      endif

      if(effective_th) then 
!--------- effective theory pre-factor
         fac=4d0/dm_lam**4*gsq*V
      else
!-------- full theory => for V,A and PS is simply g_dmx**2*g_dmq**2/prop(34)**2 
!-------- for S and G need to be more careful, but G happens elsewhere and S can be done 
!-------- in special routine
         s34=(p(3,4)+p(4,4))**2
     &        -(p(3,1)+p(4,1))**2
     &        -(p(3,2)+p(4,2))**2-(p(3,3)+p(4,3))**2         
         cprop=cone/cplx2((s34-medmass**2),medmass*medwidth)
         propsq=abs(cprop)**2 
         fac=4d0*gsq*V*propsq*g_dmq**2*g_dmx**2
      endif
      

      qqbg_sum(:)=0d0
      qbqg_sum(:)=0d0 
      qgqb_sum(:)=0d0 
      qbgq_sum(:)=0d0 
      gqqb_sum(:)=0d0 
      gqbq_sum(:)=0d0 

      msq(:,:)=0
    
!------- wrapper for separte operators
      if(dm_mediator=='vector') then 
         call qqb_dm_monojet_Vamps(p,1,2,5,3,4,qgqb)  
         call qqb_dm_monojet_Vamps(p,5,2,1,3,4,qbgq)
         call qqb_dm_monojet_Vamps(p,1,5,2,3,4,qqbg)  
         call qqb_dm_monojet_Vamps(p,2,5,1,3,4,qbqg)
         call qqb_dm_monojet_Vamps(p,2,1,5,3,4,gqqb)  
         call qqb_dm_monojet_Vamps(p,5,1,2,3,4,gqbq)
      elseif(dm_mediator=='axvect') then 
         call qqb_dm_monojet_Axamps(p,1,2,5,3,4,qgqb)  
         call qqb_dm_monojet_Axamps(p,5,2,1,3,4,qbgq)
         call qqb_dm_monojet_Axamps(p,1,5,2,3,4,qqbg)  
         call qqb_dm_monojet_Axamps(p,2,5,1,3,4,qbqg)
         call qqb_dm_monojet_Axamps(p,2,1,5,3,4,gqqb)  
         call qqb_dm_monojet_Axamps(p,5,1,2,3,4,gqbq)  
      elseif(dm_mediator=='scalar') then 
         call qqb_dm_monojet_Samps(p,1,2,5,3,4,qgqb)  
         call qqb_dm_monojet_Samps(p,5,2,1,3,4,qbgq)
         call qqb_dm_monojet_Samps(p,1,5,2,3,4,qqbg)  
         call qqb_dm_monojet_Samps(p,2,5,1,3,4,qbqg)
         call qqb_dm_monojet_Samps(p,2,1,5,3,4,gqqb)  
         call qqb_dm_monojet_Samps(p,5,1,2,3,4,gqbq)
         fac=fac/4d0
      elseif(dm_mediator=='pseudo') then 
         call qqb_dm_monojet_PSamps(p,1,2,5,3,4,qgqb)  
         call qqb_dm_monojet_PSamps(p,5,2,1,3,4,qbgq)
         call qqb_dm_monojet_PSamps(p,1,5,2,3,4,qqbg)  
         call qqb_dm_monojet_PSamps(p,2,5,1,3,4,qbqg)
         call qqb_dm_monojet_PSamps(p,2,1,5,3,4,gqqb)  
         call qqb_dm_monojet_PSamps(p,5,1,2,3,4,gqbq) 
         fac=fac/4d0
      elseif(dm_mediator=='gluonO') then 
!---------- Fill msq elsewhere 
         call gg_dm_monojet(p,msq) 
         return   
      elseif(dm_mediator=='scalmt') then 
!---------- Fill msq elsewhere 
         call gg_dm_top(p,msq) 
         return 
      endif

     

      do j=1,nf
      do h2=1,2
         do h3=1,2 
            do h4=1,2 
               qqbg_sum(j)=qqbg_sum(j)
     &              +abs(dmL(j)*qqbg(1,h2,h3,h4))**2
     &              +abs(dmR(j)*qqbg(2,h2,h3,h4))**2
               qbqg_sum(j)=qbqg_sum(j)
     &              +abs(dmL(j)*qbqg(1,h2,h3,h4))**2
     &              +abs(dmR(j)*qbqg(2,h2,h3,h4))**2
               qgqb_sum(j)=qgqb_sum(j)
     &              +abs(dmL(j)*qgqb(1,h2,h3,h4))**2
     &              +abs(dmR(j)*qgqb(2,h2,h3,h4))**2
               qbgq_sum(j)=qbgq_sum(j)
     &              +abs(dmL(j)*qbgq(1,h2,h3,h4))**2
     &              +abs(dmR(j)*qbgq(2,h2,h3,h4))**2
               gqqb_sum(j)=gqqb_sum(j)
     &              +abs(dmL(j)*gqqb(1,h2,h3,h4))**2
     &              +abs(dmR(j)*gqqb(2,h2,h3,h4))**2
               gqbq_sum(j)=gqbq_sum(j)
     &              +abs(dmL(j)*gqbq(1,h2,h3,h4))**2
     &              +abs(dmR(j)*gqbq(2,h2,h3,h4))**2
            enddo
         enddo
      enddo
      enddo


!---- compare to z 
!      call spinoru(5,p,za,zb) 
!      call zgamps2(1,2,4,3,5,za,zb,ztes)
!      write(6,*) ztes 
!      zt2=0d0 
!      do j=1,2
!         do k=1,2 
!            zt2=zt2+ztes(j,k)
!         enddo
!      enddo
!      write(6,*) zt2,qqbg
!      pause

!     call writeout(p)
!--- compare to paddy 
!      call pjfox_dm(2,p,pjf_msq) 
!      write(6,*) 'my qbqg ',qbqg 
!      write(6,*) 'my qqbg_sum', qqbg 
!      write(6,*) 'paddys ',pjf_msq 
!      write(6,*) 'ratio ',qqbg/pjf_msq 
!      pause

      do j=-nf,nf 
         do k=-nf,nf 
           if( (j .ne. 0) .and. (k .ne. 0) .and. (j .ne. -k)) goto 20

           if((j==0).and.(k==0)) then 
              msq(j,k)=0d0 
           elseif((j>0).and.(k<0)) then 
              msq(j,k)=aveqq*qqbg_sum(j)*fac 
           elseif((j>0).and.(k==0)) then 
              msq(j,k)=aveqg*qgqb_sum(j)*fac
           elseif((j==0).and.(k>0)) then 
              msq(j,k)=aveqg*gqqb_sum(k)*fac
           elseif((j==0).and.(k<0)) then 
              msq(j,k)=aveqg*gqbq_sum(abs(k))*fac 
           elseif((j<0).and.(k>0)) then 
              msq(j,k)=aveqq*qbqg_sum(k)*fac
           elseif((j<0).and.(k==0)) then 
              msq(j,k)=aveqg*qbgq_sum(abs(j))*fac
           endif


 20        continue 
        enddo
      enddo

     
      return 
      end 


