!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
!==== this routine generated by C.W using Mathematica, should 
!===== be checked by RKE's LaTeX script. 
      function AGTYE4s(t,u,Lx,Ly,Ls)
      implicit none
!     Results taken from hep-ph/0201274
!  C.~Anastasiou, E.~W.~N.~Glover and M.~E.~Tejeda-Yeomans,
!     Eq. A.10
      include 'src/Inc/types.f'
      real(dp):: AGTYE4s,E4sx
      real(dp):: t,u,Lx,Ly,Ls
      AGTYE4s=E4sx(t,u,Lx,Ly,Ls)
     &       +E4sx(u,t,Ly,Lx,Ls)
      return
      end


      function E4sx(t,u,Lx,Ly,Ls)
      implicit none
      include 'src/Inc/types.f'
      real(dp):: E4sx
      include 'src/Inc/zeta.f'
      real(dp)::t,u,Lx,Ly,Ls

      E4sx=(-152._dp*Lx)/9._dp+(32._dp*Ls*Lx)/3._dp
     & -(104._dp*Lx**2)/9._dp+
     & (32._dp*Ls*Lx**2)/3._dp+(32._dp*Lx**3)/9._dp+(64*pisq)/9._dp+
     & (128._dp*Lx*pisq)/9._dp+
     & (t*(41.98765432098765-(908._dp*Ls)/27._dp-
     & (152._dp*Lx**2)/9._dp+(32._dp*Ls*Lx**2)/3._dp+
     & (32._dp*Lx**3)/9._dp-20._dp*Ly+16._dp*Ls*Ly-(4._dp*Ly**2)/9._dp+
     & (16._dp*Ls*Ly**2)/3._dp+(16._dp*Ly**3)/9._dp+
     & (110*pisq)/9._dp-(2._dp*Ls*pisq)/3._dp+
     & (128._dp*Lx*pisq)/9._dp+(64._dp*Ly*pisq)/9._dp-(4*zeta3)/9._dp)
     & )/u
      return
      end

