!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine qqb_gamgam_z(p,z)
      implicit none
      include 'src/Inc/types.f'
************************************************************************
*     Authors: R.K. Ellis and John M. Campbell                         *
*     December, 2010.                                                  *
************************************************************************
      
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/cplx.h'
      include 'src/Inc/epinv.f'
      include 'src/Inc/qcdcouple.f'
      include 'src/Inc/facscale.f'
      include 'src/Inc/scale.f'
      include 'src/Inc/PR_new.f'
      include 'src/Inc/agq.f'
      integer:: is
      real(dp):: z,xl12,p(mxpart,4),dot,ii_qq,ii_qg,
     & tempqq,tempqg,tempgg

      xl12=log(two*dot(p,1,2)/musq)
c----contributions for one leg

      tempgg=0._dp
c---- NOTE: this contribution removes the AP subtraction for the qa->g
c----       splitting that is normally automatically included in virtint
c      do is=1,3
c      Q1(g,q,g,is)=0._dp
c      Q1(g,a,g,is)=0._dp
c      Q2(g,q,g,is)=0._dp
c      Q2(g,a,g,is)=0._dp
c      enddo
c      Q1(g,q,g,2)=-ason2pi*Cf*(1._dp+(1._dp-z)**2)/z
c     &            *(epinv+log(scale/facscale))
c      Q1(g,a,g,2)=Q1(g,q,g,2)
c      Q2(g,q,g,2)=Q1(g,q,g,2)
c      Q2(g,a,g,2)=Q1(g,q,g,2)
      
      do is=1,3
      tempqq=+ason2pi*cf*ii_qq(z,xl12,is)
      tempqg=+ason2pi*tr*ii_qg(z,xl12,is)
! JC removing gg contribution
c--- Comment out the following line to remove gg contribution
!      tempgg=+ason2pi*xn*ii_gg(z,xl12,is)
      
      Q1(q,q,a,is)=tempqq
      Q2(a,a,q,is)=tempqq
      Q1(a,a,q,is)=tempqq
      Q2(q,q,a,is)=tempqq

      Q2(a,g,q,is)=tempqg
      Q2(q,g,a,is)=tempqg
      Q1(a,g,q,is)=tempqg
      Q1(q,g,a,is)=tempqg

      Q1(g,g,g,is)=tempgg
      Q2(g,g,g,is)=tempgg
      enddo

      return
      end
