!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      function Lsm1DS(s,t,msq)
      implicit none
      include 'src/Inc/types.f'
      complex(dp):: Lsm1DS
c--- This is an implementation of Eq. (B.2) from DS, 0906.0008
      
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/cplx.h'
      real(dp):: s,t,msq,r1,r2,omr1,omr2,ddilog
      complex(dp):: dilog1,dilog2,Lnrat
      r1=s/msq
      r2=t/msq
      omr1=one-r1
      omr2=one-r2
      if (omr1 > one) then 
       dilog1=cplx1(pisqo6-ddilog(r1))
     & -Lnrat(-s,-msq)*cplx1(log(omr1))
      else
       dilog1=cplx1(ddilog(omr1))
      endif
      if (omr2 > one) then 
       dilog2=cplx1(pisqo6-ddilog(r2))
     & -Lnrat(-t,-msq)*cplx1(log(omr2))
      else
       dilog2=cplx1(ddilog(omr2))
      endif
      Lsm1DS=dilog1+dilog2+Lnrat(-s,-msq)*Lnrat(-t,-msq)-cplx1(pisqo6)
      return
      end

