!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
c--- converts integer kpart to corresponding 4-character string
      function kpartstring(k)
      implicit none
      include 'src/Inc/kpart.f'
      character*20 kpartstring
      integer k

      if     (k == klord) then
        kpartstring='lo'
      elseif (k == kvirt) then
        kpartstring='virt'
      elseif (k == kreal) then
        kpartstring='real'
      elseif (k == ktota) then
        kpartstring='nlo'
      elseif (k == kfrag) then
        kpartstring='frag'
      elseif (k == ktodk) then
        kpartstring='todk'
      elseif (k == ksnlo) then
        kpartstring='snlo'
      elseif (k == knnlo) then
        kpartstring='nnlo'
      elseif (k == kresummed .and. kresorder == 4) then
          if (krespart == kresexp) then
              kpartstring = 'resexpNLO'
          elseif (krespart == kresonly) then
              kpartstring = 'resonlyNLO'
          elseif (krespart == kresabove) then
              kpartstring = 'resaboveNLO'
          elseif (krespart == kresmatchcorr) then
              kpartstring = 'resmatchcorrNLO'
          else
              kpartstring='resNLO'
          endif
      elseif (k == kresummed .and. kresorder == 6) then
          if (krespart == kresexp) then
              kpartstring = 'resexp'
          elseif (krespart == kresonly) then
              kpartstring = 'resonly'
          elseif (krespart == kresabove) then
              kpartstring = 'above'
          elseif (krespart == kresmatchcorr) then
              kpartstring = 'resmatchcorr'
          else
              kpartstring='resNNLO'
          endif
      else
        write(6,*) 'Unexpected kpart in kpartstring: ',k
        stop
      endif

      if (coeffonly) then
        kpartstring=trim(kpartstring)//'coeff'
      endif

      return
      end

      
