!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      function lnrat(x,y)
      implicit none
      include 'src/Inc/types.f'
      include 'src/Inc/cplx.h'
      complex(dp):: lnrat
************************************************************************
*     Author: R.K. Ellis                                               *
*     August, 1998.                                                    *
c     lnrat(x,y)=log(x-i*ep)-log(y-i*ep)                               *
c     this function is hard-wired for sign of epsilon we must adjust   *
c     sign of x and y to get the right sign for epsilon                *
************************************************************************
      include 'src/Inc/constants.f'
       real(dp):: x,y,htheta
C--- define Heaviside theta function (=1 for x>0) and (0 for x < 0)
      htheta(x)=half+half*sign(one,x)
!---  end statement function
      lnrat=cplx1(log(abs(x/y)))
     & -impi*(htheta(-x)-htheta(-y))
      return
      end

