!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine ttggZdriver(p,etatb,etat,ampsq1,ampsq2,ampsq0)
      implicit none
      include 'src/Inc/types.f'
C     Calculate the matrix elements squared for the process
C      g(-p1)+g(-p2)-->l(p3)+a(p4)+t(p5)+t~(p6)
C     eta5 is the vector chosen to make the  t~ massleses
C     eta6 is the vector chosen to make the  t massleses
      
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/cplx.h'
      include 'src/Inc/zcouple.f'
      include 'src/Inc/ewcharge.f'
      include 'src/Inc/masses.f'
      real(dp):: p(mxpart,4),s34,ampsq1,ampsq2,ampsq0
      integer:: h1,h2,h3,h4,h56,etatb,etat
      complex(dp):: ampAB(2,2,2,2,2),ampBA(2,2,2,2,2),prop,
     & ampQED(2,2,2,2,2),
     & XABL(2,2,2,2,2),XABR(2,2,2,2,2),
     & XBAL(2,2,2,2,2),XBAR(2,2,2,2,2)
      call ttggZamp(p,6,5,1,2,3,4,etatb,etat,XABL,XABR)
      call ttggZamp(p,6,5,2,1,3,4,etatb,etat,XBAL,XBAR)

C     In the call s34 is the mass^2 of the lepton pair
      s34=2d0*(p(3,4)*p(4,4)-p(3,1)*p(4,1)-p(3,2)*p(4,2)-p(3,3)*p(4,3))
      prop=s34/cplx2(s34-zmass**2,zmass*zwidth)

      do h1=1,2
      do h2=1,2
      do h3=1,2
      do h4=1,2
      h56=1
      ampAB(h1,h2,h3,h4,h56)=
     &  (Q(2)*q1+L(2)*l1*prop)*XABL(h1,h2,h3,h4,h56)
     & +(Q(2)*q1+R(2)*l1*prop)*XABR(h1,h2,h3,h4,h56)
      ampBA(h1,h2,h3,h4,h56)=
     &  (Q(2)*q1+L(2)*l1*prop)*XBAL(h1,h2,h4,h3,h56)
     & +(Q(2)*q1+R(2)*l1*prop)*XBAR(h1,h2,h4,h3,h56)
      h56=2
      ampAB(h1,h2,h3,h4,h56)=
     &  (Q(2)*q1+L(2)*r1*prop)*XABL(h1,h2,h3,h4,h56)
     & +(Q(2)*q1+R(2)*r1*prop)*XABR(h1,h2,h3,h4,h56)
      ampBA(h1,h2,h3,h4,h56)=
     &  (Q(2)*q1+L(2)*r1*prop)*XBAL(h1,h2,h4,h3,h56)
     & +(Q(2)*q1+R(2)*r1*prop)*XBAR(h1,h2,h4,h3,h56)
      enddo
      enddo
      enddo
      enddo

      ampsq0=0d0
      ampsq1=0d0
      ampsq2=0d0
      do h1=1,2
      do h2=1,2
      do h3=1,2
      do h4=1,2
      do h56=1,2
      ampQED(h1,h2,h3,h4,h56)=
     & ampAB(h1,h2,h3,h4,h56)+ampBA(h1,h2,h3,h4,h56)
      ampsq1=ampsq1
     &  +real(ampAB(h1,h2,h3,h4,h56)*conjg(ampAB(h1,h2,h3,h4,h56)))
      ampsq2=ampsq2
     &  +real(ampBA(h1,h2,h3,h4,h56)*conjg(ampBA(h1,h2,h3,h4,h56)))
      ampsq0=ampsq0
     & -real(ampQED(h1,h2,h3,h4,h56)*conjg(ampQED(h1,h2,h3,h4,h56)))
     & /xn**2
      enddo
      enddo
      enddo
      enddo
      enddo

      return
      end
