!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine dkW2qqb_QQb_gs(p,msqc)
      implicit none
      include 'src/Inc/types.f'
      
************************************************************************
*     Author: R.K. Ellis                                               *
*     November, 2011.                                                  *
*     calculate the subtraction term for radiation in the              *
*     anti-top quark decay for the process                             *
*                                                                      *
*     q(-p1)+qbar(-p2) = nu(p3)+e+(p4)+b(p5)                           *
*                        +bbar(p6)+e-(p7)+nubar(p8)+g(p9)              *
*                                                                      *
*     Top is kept strictly on-shell although all spin correlations     *
*     are retained. B-quark is taken to be either massless or massive  *
*                                                                      *
************************************************************************
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/cplx.h'
      include 'src/Inc/masses.f'
      include 'src/Inc/ptilde.f'
      include 'src/Inc/qcdcouple.f'
      include 'src/Inc/alfacut.f'
      include 'src/Inc/qqgg.f'
      include 'src/Inc/incldip.f'
      real(dp):: msqc(maxd,-nf:nf,-nf:nf),
     & p(mxpart,4)
      real(dp):: 
     & msq79_8(-nf:nf,-nf:nf),msq89_7(-nf:nf,-nf:nf),
     & dummyv(-nf:nf,-nf:nf),sub79_8(4),sub89_7(4),dsubv
      integer:: j,k,nd
      external qqb_QQbdk,donothing_gvec

      ndmax=2
      
      do j=-nf,nf
      do k=-nf,nf
      do nd=1,ndmax
        msqc(nd,j,k)=0._dp
        incldip(nd)=.true.
      enddo
      enddo
      enddo

      call dips(1,p,7,9,8,sub79_8,dsubv,msq79_8,dummyv,
     & qqb_QQbdk,donothing_gvec)
      call dips(2,p,8,9,7,sub89_7,dsubv,msq89_7,dummyv,
     & qqb_QQbdk,donothing_gvec)
      do j=-nf,nf
        k=-j
        msqc(1,j,k)=sub79_8(qq)*msq79_8(j,k)*2._dp*cf
        msqc(2,j,k)=sub89_7(qq)*msq89_7(j,k)*2._dp*cf
      enddo
            
      return
      end

