!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      function A1slcqqppmp(e1,p2,p3,e4,za,zb,zab,zba)
      implicit none
      include 'src/Inc/types.f'
      complex(dp):: A1slcqqppmp
      
C-----Authors: John Campbell and Keith Ellis, November 2011
C---- taken from arXiv:1101.5947 [hep-ph], Eq. (56)
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/cplx.h'
      include 'src/Inc/masses.f'
      include 'src/Inc/zprods_decl.f'
      include 'src/Inc/sprods_com.f'
      include 'src/Inc/zabprods_decl.f'
      include 'src/Inc/epinv.f'
      include 'src/Inc/scale.f'
      real(dp):: mt2,beta,xlog
      complex(dp):: BSYA0qqppmp,BSYA1slcqqppmp,Vslc,lnrat
      integer:: e1,p2,p3,e4
      mt2=mt**2 
      beta=sqrt(1d0-4d0*mt2/s(p2,p3))
      xlog=log((1d0-beta)/(1d0+beta))/beta
c--- NB: added a minus sign in front of the double pole compared to Eq. (56)
      Vslc=-cplx1(epinv**2)-cplx1(epinv)*(1d0
     & +lnrat(musq,-s(p2,p3))+(1d0-2d0*mt2/s(p2,p3))*xlog)
      A1slcqqppmp=Vslc*BSYA0qqppmp(e1,p2,p3,e4,za,zb,zab,zba)
     &                +BSYA1slcqqppmp(e1,p2,p3,e4,za,zb,zab,zba)  
      
      return
      end
