!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      function BSYA0qedpppp(e1,p2,p3,e4,za,zb,zab,zba)
      implicit none
      include 'src/Inc/types.f'
      complex(dp):: BSYA0qedpppp
      
C-----Authors: John Campbell and Keith Ellis, November 2011
C---- arXiv:1101.5947 [hep-ph], Eq. (A7)
C---- These are the twiddle functions arXiv:1101.5947 [hep-ph], Eq. (91)
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/cplx.h'
      include 'src/Inc/masses.f'
      include 'src/Inc/zprods_decl.f'
      include 'src/Inc/zabprods_decl.f'
      include 'src/Inc/qdef.f'
      integer:: e1,p2,p3,e4
      BSYA0qedpppp=mt**3*za(e1,e4)*zb(p2,p3)**2
     & /(zab(p2,q1,p2)*zab(p3,q1,p3))

c--- flip sign to agree with BSY code
      BSYA0qedpppp=-BSYA0qedpppp
      
      return
      end
