!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine cross(p,i,j,r)
      implicit none
      include 'src/Inc/types.f'
      
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      integer:: i,j
      real(dp):: p(mxpart,4),r(3)
      
      r(1)=p(i,2)*p(j,3)-p(j,2)*p(i,3)
      r(2)=p(i,3)*p(j,1)-p(j,3)*p(i,1)
      r(3)=p(i,1)*p(j,2)-p(j,1)*p(i,2)
      
      return
      end
            
      function fphi(n1,n2,p)
      implicit none
      include 'src/Inc/types.f'
      real(dp):: fphi
      
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      integer:: n1,n2
      real(dp):: p(mxpart,4)
    
      fphi=p(n1,1)*p(n2,1)+p(n1,2)*p(n2,2)
      fphi=fphi/sqrt(p(n1,1)**2+p(n1,2)**2)
      fphi=fphi/sqrt(p(n2,1)**2+p(n2,2)**2)
      if     (fphi > +0.9999999_dp) then
        fphi=0._dp
      elseif (fphi < -0.9999999_dp) then
        fphi=pi
      else
        fphi=acos(fphi)
      endif

      return
      end
                     
      function coslpairet(n1,n2,nm1,nm2,p)
      implicit none
      include 'src/Inc/types.f'
      real(dp):: coslpairet
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      integer:: n1,n2,nm1,nm2,i
      real(dp):: p(mxpart,4),misset(4),pp(4)
      
      if (nm2 == 0) then
        do i=1,4
          misset(i)=p(nm1,i)
        enddo
      else
        do i=1,4
          misset(i)=p(nm1,i)+p(nm2,i)
        enddo
      endif
      
      do i=1,4
        pp(i)=p(n1,i)+p(n2,i)
      enddo
      
      coslpairet=pp(1)*misset(1)+pp(2)*misset(2)
      coslpairet=coslpairet/sqrt(pp(1)**2+pp(2)**2)
      coslpairet=coslpairet/sqrt(misset(1)**2+misset(2)**2)
      
      return
      end
            
      function deltar(i,j,p)
      implicit none
      include 'src/Inc/types.f'
      real(dp):: deltar
      include 'src/Inc/constants.f'
      include 'src/Inc/mxpart.f'
      real(dp):: p(mxpart,4),phi1,phi2,etarap,dphi
      integer:: i,j
      
      phi1=atan2(p(i,1),p(i,2))
      phi2=atan2(p(j,1),p(j,2))
      dphi=phi1-phi2
      if (dphi > pi) dphi=twopi-dphi
      if (dphi < -pi) dphi=twopi+dphi
      deltar=(etarap(i,p)-etarap(j,p))**2+dphi**2
      deltar=sqrt(deltar)
      
      return
      end
      
