!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
module nplotter_singletop
      use MCFMPlotting
      implicit none

      public :: setup, book
      private

      integer, save, allocatable :: histos(:)

      contains

      subroutine setup()
          use types
          implicit none

          allocate(histos(4))

          histos(1) = plot_setup_uniform(0._dp,80._dp,1._dp,'pt6')
          histos(2) = plot_setup_uniform(0._dp,80._dp,1._dp,'pt5')
          histos(3) = plot_setup_custom([0._dp,50._dp,150._dp,600._dp,1000._dp],'pt5 large')
          histos(4) = plot_setup_custom([0._dp,1._dp],'all')

      end subroutine

      subroutine book(p,wt,ids,vals,wts)
          use types
          implicit none
          include 'src/Inc/mxpart.f'

          real(dp), intent(in) :: p(mxpart,4), wt
          integer, allocatable, intent(out) :: ids(:)
          real(dp), allocatable, intent(out) :: vals(:)
          real(dp), allocatable, intent(out) :: wts(:)

          real(dp) :: pt

          real(dp) :: pt5,pt6

          pt5 = pt(5,p)
          pt6 = pt(6,p)

          ids = histos

          vals = [pt6,pt5,pt5,0.5_dp]

      end subroutine

end module
