!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      function Fsc7(j1,j2,j3,j4,j5,j6,za,zb) 
      implicit none
      include 'src/Inc/types.f'
      complex(dp):: Fsc7
      
      include 'src/Inc/mxpart.f'
      include 'src/Inc/zprods_decl.f'
      include 'src/Inc/sprods_com.f'
      integer:: j1,j2,j3,j4,j5,j6
      complex(dp):: L0,L1,Lsm1,Lsm1_2mh,I3m,Lnrat,Ls1
      real(dp):: t  
      complex(dp):: tmp

      Fsc7= 
     .-((Lsm1(-s(j1,j2),-t(j1,j2,j4),-s(j1,j4),-t(j1,j2,j4))*zb(j1,j4)*
     .(-(za(j1,j5)*zb(j1,j2))+za(j4,j5)*zb(j2,j4))**2)/
     .(za(j5,j6)*zb(j2,j4)**2*(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4
     .))*
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4))))-
     .(za(j2,j4)*(-((L0(-t(j1,j2,j4),-s(j1,j2))*zb(j1,j2)*
     .(-(za(j1,j5)*zb(j1,j4))-za(j2,j5)*zb(j2,j4))**2)/
     .(s(j1,j2)*(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))))-
     .(L0(-t(j1,j2,j4),-s(j1,j4))*zb(j1,j4)*
     .(-(za(j1,j5)*zb(j1,j2))+za(j4,j5)*zb(j2,j4))**2)/
     .(s(j1,j4)*(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4)))))/
     .(za(j5,j6)*zb(j2,j4)*(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4)))
     .+
     .(za(j1,j5)*za(j4,j5)*(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3)))
     ./
     .(2._dp*za(j3,j4)*za(j5,j6)*(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j
     .4))*
     .(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4)))+
     .(za(j1,j5)*(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3))*
     .((za(j1,j4)*((s(j1,j2)-s(j3,j4)-s(j5,j6))*za(j2,j5)*zb(j1,j2)+
     .(-s(j1,j2)-s(j3,j4)+s(j5,j6))*za(j5,j6)*zb(j1,j6)))/za(j3,j4)
     .-((-s(j1,j2)-s(j3,j4)+s(j5,j6))*za(j2,j5)+
     .2._dp*za(j1,j2)*(za(j3,j5)*zb(j1,j3)+za(j4,j5)*zb(j1,j4)))*
     .zb(j2,j3)))/
     .(2._dp*(s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s
     .(j5,j6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)*za(j5,j6)*
     .(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4))*
     .(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4)))-
     .(Lnrat(-s(j1,j2),-s(j5,j6))*za(j3,j5)*
     .(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3))*
     .(-(za(j2,j5)*zb(j2,j3))+za(j4,j5)*zb(j3,j4)))/
     .(2._dp*s(j3,j4)*za(j5,j6)*(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4
     .))*
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4)))-
     .(za(j3,j5)*(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3))*
     .((za(j3,j5)*zb(j1,j2)*((-s(j1,j2)-s(j3,j4)+s(j5,j6))*za(j2,j4)+
     .2._dp*za(j1,j2)*za(j3,j4)*zb(j1,j3)))/za(j3,j4)-
     .((-(za(j1,j5)*zb(j1,j4))-za(j2,j5)*zb(j2,j4))*
     .((-s(j1,j2)-s(j3,j4)+s(j5,j6))*zb(j1,j3)+
     .2._dp*za(j2,j4)*zb(j1,j2)*zb(j3,j4)))/zb(j3,j4)))/
     .(2._dp*(s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s
     .(j5,j6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)*za(j5,j6)*
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))*
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4)))+
     .((-(za(j2,j3)*zb(j1,j3))-za(j2,j4)*zb(j1,j4))*
     .(((s(j1,j4)-s(j2,j3)-s(j5,j6))*za(j2,j5)*za(j4,j5))/
     .(za(j2,j3)*za(j5,j6))+
     .((-s(j1,j4)-s(j2,j3)+s(j5,j6))*za(j2,j5)*zb(j1,j6))/
     .(2._dp*za(j2,j3)*zb(j1,j4))+za(j4,j5)*zb(j3,j6)))/
     .(2._dp*(s(j1,j4)**2-2._dp*s(j1,j4)*s(j2,j3)+s(j2,j3)**2-2._dp*s(j1,j4)*s
     .(j5,j6)-
     .2._dp*s(j2,j3)*s(j5,j6)+s(j5,j6)**2)*
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4)))+
     .((-(za(j2,j3)*zb(j1,j3))-za(j2,j4)*zb(j1,j4))*
     .(((-s(j1,j4)-s(j2,j3)+s(j5,j6))*za(j2,j5)*zb(j1,j6))/
     .(2._dp*za(j2,j3)*zb(j1,j4))+za(j4,j5)*zb(j3,j6)-
     .((-s(j1,j4)+s(j2,j3)-s(j5,j6))*zb(j1,j6)*zb(j3,j6))/
     .(zb(j1,j4)*zb(j5,j6))))/
     .(2._dp*(s(j1,j4)**2-2._dp*s(j1,j4)*s(j2,j3)+s(j2,j3)**2-2._dp*s(j1,j4)*s
     .(j5,j6)-
     .2._dp*s(j2,j3)*s(j5,j6)+s(j5,j6)**2)*
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4)))+
     .((za(j2,j4)**2*za(j3,j5)**2*zb(j1,j2))/(za(j2,j3)*za(j3,j4)*za(j5,
     .j6))-
     .(za(j3,j5)*zb(j1,j3)*zb(j3,j6))/zb(j3,j4)+
     .((za(j2,j3)*zb(j1,j2)-za(j3,j4)*zb(j1,j4))*zb(j1,j6)*zb(j3,j6))/
     .(zb(j1,j4)*zb(j5,j6)))/
     .(2._dp*(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))*
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4)))+
     .(-((za(j2,j5)*za(j4,j5)*(-(za(j1,j2)*zb(j1,j4))+za(j2,j3)*zb(j3,j4
     .)))/
     .(za(j2,j3)*za(j5,j6)))+
     .(za(j2,j4)*za(j4,j5)*zb(j4,j6))/za(j3,j4)-
     .(za(j1,j2)*zb(j1,j3)**2*zb(j4,j6)**2)/(zb(j1,j4)*zb(j3,j4)*zb(j5,j
     .6)))/
     .(2._dp*(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))*
     .(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4)))+
     .((-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3))*zb(j2,j6)*zb(j3,j6))
     ./
     .(2._dp*(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4))*
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4))*zb(j3,j4)*zb(j5,j6))+
     .(Lsm1(-s(j1,j2),-t(j1,j2,j3),-s(j2,j3),-t(j1,j2,j3))*za(j2,j3)*
     .(za(j1,j2)*zb(j2,j6)+za(j1,j3)*zb(j3,j6))**2)/
     .(za(j1,j3)**2*(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))*
     .(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4))*zb(j5,j6))+
     .(zb(j1,j3)*((L0(-t(j1,j2,j3),-s(j1,j2))*za(j1,j2)*
     .(-(za(j1,j3)*zb(j1,j6))-za(j2,j3)*zb(j2,j6))**2)/
     .(s(j1,j2)*(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4)))-
     .(L0(-t(j1,j2,j3),-s(j2,j3))*za(j2,j3)*
     .(za(j1,j2)*zb(j2,j6)+za(j1,j3)*zb(j3,j6))**2)/
     .(s(j2,j3)*(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4)))))/
     .(za(j1,j3)*(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))*zb(j5,j6))

      Fsc7=Fsc7
     .+
     .(Lnrat(-s(j1,j2),-s(j5,j6))*(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j
     .2,j3))*
     .(-(za(j1,j4)*zb(j1,j6))-za(j3,j4)*zb(j3,j6))*zb(j4,j6))/
     .(2._dp*s(j3,j4)*(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4))*
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))*zb(j5,j6))+
     .((-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3))*zb(j4,j6)*
     .((((-s(j1,j2)-s(j3,j4)+s(j5,j6))*za(j2,j4)+
     .2._dp*za(j1,j2)*za(j3,j4)*zb(j1,j3))*
     .(-(za(j1,j3)*zb(j1,j6))-za(j2,j3)*zb(j2,j6)))/za(j3,j4)+
     .(za(j1,j2)*((-s(j1,j2)-s(j3,j4)+s(j5,j6))*zb(j1,j3)+
     .2._dp*za(j2,j4)*zb(j1,j2)*zb(j3,j4))*zb(j4,j6))/zb(j3,j4)))/
     .(2._dp*(s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s
     .(j5,j6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)*
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))*
     .(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4))*zb(j5,j6))-
     .((-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3))*zb(j2,j6)*
     .(-(za(j1,j4)*((-s(j1,j2)-s(j3,j4)+s(j5,j6))*zb(j1,j6)-
     .2._dp*zb(j1,j2)*(za(j2,j3)*zb(j3,j6)+za(j2,j4)*zb(j4,j6))))-
     .(zb(j2,j3)*(-((s(j1,j2)-s(j3,j4)-s(j5,j6))*za(j1,j2)*zb(j1,j6))-
     .(-s(j1,j2)-s(j3,j4)+s(j5,j6))*za(j2,j5)*zb(j5,j6)))/zb(j3,j4))
     .)/(2._dp*(s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)
     .*s(j5,j6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)*
     .(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4))*
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4))*zb(j5,j6))+
     .I3m(s(j1,j4),s(j2,j3),s(j5,j6))*
     .(-(((-(za(j2,j3)*zb(j1,j3))-za(j2,j4)*zb(j1,j4))*
     .(-(za(j1,j4)*za(j2,j5)*zb(j1,j6)*zb(j2,j3))+
     .(za(j4,j5)*(-2._dp*za(j2,j5)*zb(j2,j3)-za(j5,j6)*zb(j3,j6))*
     .zb(j5,j6))/2))/
     .((s(j1,j4)**2-2._dp*s(j1,j4)*s(j2,j3)+s(j2,j3)**2-2._dp*s(j1,j4)*s(j5,
     .j6)-
     .2._dp*s(j2,j3)*s(j5,j6)+s(j5,j6)**2)*
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))))+
     .(3._dp*za(j1,j4)*(-(za(j2,j3)*zb(j1,j3))-za(j2,j4)*zb(j1,j4))*zb(j2,
     .j3)*
     .(((-s(j1,j4)-s(j2,j3)+s(j5,j6))*za(j2,j5)*za(j5,j6)*zb(j1,j6)*
     .zb(j5,j6))/2+za(j4,j5)*zb(j1,j4)*
     .(-(s(j5,j6)*za(j2,j3)*zb(j3,j6))+
     .(s(j1,j4)-s(j2,j3)-s(j5,j6))*za(j2,j5)*zb(j5,j6))))/
     .((s(j1,j4)**2-2._dp*s(j1,j4)*s(j2,j3)+s(j2,j3)**2-2._dp*s(j1,j4)*s(j5,
     .j6)-
     .2._dp*s(j2,j3)*s(j5,j6)+s(j5,j6)**2)**2*
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))))


      Fsc7=Fsc7+
     .I3m(s(j2,j3),s(j1,j4),s(j5,j6))*
     .((3._dp*za(j1,j4)*(-(za(j2,j3)*zb(j1,j3))-za(j2,j4)*zb(j1,j4))*zb(j2
     .,j3)*
     .(za(j2,j3)*(-(s(j5,j6)*za(j4,j5)*zb(j1,j4))-
     .(-s(j1,j4)+s(j2,j3)-s(j5,j6))*za(j5,j6)*zb(j1,j6))*
     .zb(j3,j6)+((-s(j1,j4)-s(j2,j3)+s(j5,j6))*za(j2,j5)*
     .za(j5,j6)*zb(j1,j6)*zb(j5,j6))/2))/
     .((s(j1,j4)**2-2._dp*s(j1,j4)*s(j2,j3)+s(j2,j3)**2-2._dp*s(j1,j4)*s(j5,
     .j6)-
     .2._dp*s(j2,j3)*s(j5,j6)+s(j5,j6)**2)**2*
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4)))-
     .((-(za(j2,j3)*zb(j1,j3))-za(j2,j4)*zb(j1,j4))*
     .(-(za(j1,j4)*za(j2,j5)*zb(j1,j6)*zb(j2,j3))-
     .(za(j5,j6)*zb(j3,j6)*
     .(-2._dp*za(j1,j4)*zb(j1,j6)+za(j4,j5)*zb(j5,j6)))/2))/
     .((s(j1,j4)**2-2._dp*s(j1,j4)*s(j2,j3)+s(j2,j3)**2-2._dp*s(j1,j4)*s(j5,
     .j6)-
     .2._dp*s(j2,j3)*s(j5,j6)+s(j5,j6)**2)*
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))))+
     .Lnrat(-s(j1,j4),-s(j5,j6))*((4._dp*za(j2,j4)*za(j2,j5)*zb(j1,j6)*zb(
     .j2,j3)+
     .(2._dp*za(j4,j5)*(-(za(j2,j3)*zb(j1,j3))-za(j2,j4)*zb(j1,j4))*
     .((s(j1,j4)-s(j2,j3)-s(j5,j6))*za(j2,j5)+
     .2._dp*za(j2,j3)*za(j5,j6)*zb(j3,j6)))/(za(j2,j3)*za(j5,j6))+
     .((s(j1,j4)-s(j2,j3)-s(j5,j6))*za(j2,j4)+
     .za(j1,j4)*za(j2,j5)*zb(j1,j5)+za(j1,j4)*za(j2,j6)*zb(j1,j6))*
     .(-((za(j2,j5)*(za(j2,j5)*zb(j1,j2)+za(j3,j5)*zb(j1,j3)))/
     .(za(j2,j3)*za(j5,j6)))+(zb(j1,j6)*zb(j3,j6))/zb(j5,j6)))/
     .(2._dp*(s(j1,j4)**2-2._dp*s(j1,j4)*s(j2,j3)+s(j2,j3)**2-2._dp*s(j1,j4)*s
     .(j5,j6)-
     .2._dp*s(j2,j3)*s(j5,j6)+s(j5,j6)**2)*
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4)))+
     .(3._dp*za(j1,j4)*(-(za(j2,j3)*zb(j1,j3))-za(j2,j4)*zb(j1,j4))*
     .(((s(j1,j4)-s(j2,j3)-s(j5,j6))*za(j4,j5)*zb(j1,j4)+
     .(-s(j1,j4)-s(j2,j3)+s(j5,j6))*za(j5,j6)*zb(j1,j6))*zb(j3,j6)
     .-za(j2,j5)*zb(j2,j3)*((-s(j1,j4)+s(j2,j3)-s(j5,j6))*zb(j1,j6)-
     .2._dp*za(j4,j5)*zb(j1,j4)*zb(j5,j6))))/
     .((s(j1,j4)**2-2._dp*s(j1,j4)*s(j2,j3)+s(j2,j3)**2-2._dp*s(j1,j4)*s(j5,
     .j6)-
     .2._dp*s(j2,j3)*s(j5,j6)+s(j5,j6)**2)**2*
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))))+
     .Lnrat(-s(j2,j3),-s(j5,j6))*((3._dp*(-(za(j2,j3)*zb(j1,j3))-za(j2,j4)
     .*zb(j1,j4))*
     .zb(j2,j3)*(-(za(j1,j4)*zb(j1,j6)*
     .((s(j1,j4)-s(j2,j3)-s(j5,j6))*za(j2,j5)+
     .2._dp*za(j2,j3)*za(j5,j6)*zb(j3,j6)))+
     .za(j4,j5)*((-s(j1,j4)+s(j2,j3)-s(j5,j6))*za(j2,j3)*zb(j3,j6)-
     .(-s(j1,j4)-s(j2,j3)+s(j5,j6))*za(j2,j5)*zb(j5,j6))))/
     .((s(j1,j4)**2-2._dp*s(j1,j4)*s(j2,j3)+s(j2,j3)**2-2._dp*s(j1,j4)*s(j5,
     .j6)-
     .2._dp*s(j2,j3)*s(j5,j6)+s(j5,j6)**2)**2*
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4)))+
     .(4._dp*za(j1,j4)*za(j2,j5)*zb(j1,j3)*zb(j1,j6)+
     .((-s(j1,j4)+s(j2,j3)-s(j5,j6))*zb(j1,j3)+
     .za(j2,j5)*zb(j1,j5)*zb(j2,j3)+za(j2,j6)*zb(j1,j6)*zb(j2,j3))*
     .(-((za(j2,j5)*za(j4,j5))/za(j5,j6))+
     .(zb(j1,j6)*(-(za(j1,j2)*zb(j1,j6))+za(j2,j4)*zb(j4,j6)))/
     .(zb(j1,j4)*zb(j5,j6)))-
     .(2._dp*(-(za(j2,j3)*zb(j1,j3))-za(j2,j4)*zb(j1,j4))*zb(j3,j6)*
     .((-s(j1,j4)+s(j2,j3)-s(j5,j6))*zb(j1,j6)-
     .2._dp*za(j4,j5)*zb(j1,j4)*zb(j5,j6)))/(zb(j1,j4)*zb(j5,j6)))/
     .(2._dp*(s(j1,j4)**2-2._dp*s(j1,j4)*s(j2,j3)+s(j2,j3)**2-2._dp*s(j1,j4)*s
     .(j5,j6)-
     .2._dp*s(j2,j3)*s(j5,j6)+s(j5,j6)**2)*
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))))

      Fsc7=Fsc7
     .+(Lnrat(-s(j1,j2),-s(j5,j6))*za(j1,j2)*
     .((-6._dp*zb(j1,j2)*((-s(j1,j2)-s(j3,j4)+s(j5,j6))*za(j2,j3)-
     .2._dp*za(j1,j2)*za(j3,j4)*zb(j1,j4))*
     .(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3))*
     .(-(za(j1,j5)*zb(j1,j6))-za(j2,j5)*zb(j2,j6)))/
     .(s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s(j5,j
     .6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)**2-
     .((-(za(j1,j3)*zb(j1,j6))-za(j2,j3)*zb(j2,j6))*
     .(zb(j1,j6)*zb(j3,j4)-zb(j1,j3)*zb(j4,j6)))/
     .((-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))*zb(j3,j4)*
     .zb(j5,j6))+(-((za(j4,j5)*
     .(2._dp*((-s(j1,j2)+s(j3,j4)-s(j5,j6))*za(j3,j5)*
     .zb(j1,j3)+
     .(-s(j1,j2)-s(j3,j4)+s(j5,j6))*za(j5,j6)*zb(j1,j6))
     .+za(j4,j5)*(za(j2,j3)*zb(j1,j2)-za(j3,j4)*zb(j1,j4))*zb(j3,j4)))/
     .za(j5,j6))-((s(j1,j2)-s(j3,j4)-s(j5,j6))*za(j2,j3)*
     .zb(j1,j2)*(-(za(j3,j5)*zb(j3,j6))+za(j4,j5)*zb(j4,j6)))/
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))-
     .(za(j2,j4)*zb(j1,j2)*
     .(-(za(j1,j3)*zb(j1,j6))-za(j2,j3)*zb(j2,j6))*zb(j3,j6))/
     .zb(j5,j6)-(zb(j1,j2)*zb(j4,j6)*
     .(-((2._dp*(s(j1,j2)-s(j3,j4)-s(j5,j6))*za(j2,j4)+
     .za(j1,j2)*za(j3,j4)*zb(j1,j3))*zb(j3,j6))+
     .((s(j1,j2)-s(j3,j4)-s(j5,j6))*za(j2,j3)*
     .(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3))*
     .zb(j4,j6))/
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))))/
     .(zb(j3,j4)*zb(j5,j6))+
     .((s(j1,j2)-s(j3,j4)-s(j5,j6))*zb(j1,j4)*zb(j3,j6)*
     .(-(za(j1,j4)*zb(j1,j6))-za(j2,j4)*zb(j2,j6)-
     .za(j4,j5)*zb(j5,j6)))/(zb(j3,j4)*zb(j5,j6))+
     .za(j4,j5)*(-(za(j2,j3)*zb(j1,j2)*zb(j3,j6))+
     .za(j4,j5)*zb(j1,j4)*zb(j5,j6))+
     .4._dp*za(j3,j5)*zb(j1,j2)*
     .(za(j2,j4)*zb(j3,j6)-
     .(za(j2,j3)*za(j4,j5)*zb(j3,j4)*zb(j5,j6))/
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))))/
     .(s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s(j5,j
     .6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)))/
     .(2._dp*za(j1,j3)*(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4)))


      Fsc7=Fsc7
     .-(Lnrat(-s(j1,j2),-s(j5,j6))*zb(j1,j2)*
     .(-(((-(za(j2,j5)*za(j3,j4))-za(j2,j4)*za(j3,j5))*
     .(-(za(j1,j5)*zb(j1,j4))-za(j2,j5)*zb(j2,j4)))/
     .(za(j3,j4)*za(j5,j6)*
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))))+
     .(6._dp*za(j1,j2)*(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3))*
     .(-(za(j1,j5)*zb(j1,j6))-za(j2,j5)*zb(j2,j6))*
     .((-s(j1,j2)-s(j3,j4)+s(j5,j6))*zb(j1,j4)-
     .2._dp*za(j2,j3)*zb(j1,j2)*zb(j3,j4)))/
     .(s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s(j5,j
     .6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)**2+
     .(-((za(j1,j2)*za(j4,j5)*zb(j1,j3)*
     .(-(za(j1,j5)*zb(j1,j4))-za(j2,j5)*zb(j2,j4)))/za(j5,j6))
     .+(za(j1,j2)*za(j3,j5)*(((s(j1,j2)-s(j3,j4)-s(j5,j6))*za(j3,j5)*
     .zb(j1,j4)*
     .(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3)))/
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))-
     .za(j4,j5)*(2._dp*(s(j1,j2)-s(j3,j4)-s(j5,j6))*zb(j1,j3)+
     .za(j2,j4)*zb(j1,j2)*zb(j3,j4))))/(za(j3,j4)*za(j5,j6))
     .+((s(j1,j2)-s(j3,j4)-s(j5,j6))*za(j2,j3)*za(j4,j5)*
     .(-(za(j1,j5)*zb(j1,j3))-za(j2,j5)*zb(j2,j3)+
     .za(j5,j6)*zb(j3,j6)))/(za(j3,j4)*za(j5,j6))+
     .zb(j3,j6)*(za(j1,j2)*za(j4,j5)*zb(j1,j4)-
     .za(j2,j3)*za(j5,j6)*zb(j3,j6))-
     .4._dp*za(j1,j2)*(za(j4,j5)*zb(j1,j3)-
     .(za(j3,j4)*za(j5,j6)*zb(j1,j4)*zb(j3,j6))/
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4)))*zb(j4,j6)+
     .((s(j1,j2)-s(j3,j4)-s(j5,j6))*za(j1,j2)*zb(j1,j4)*
     .(za(j3,j5)*zb(j3,j6)-za(j4,j5)*zb(j4,j6)))/
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))+
     .(zb(j3,j6)*(-(za(j3,j4)*
     .(-(za(j1,j2)*zb(j1,j4))+za(j2,j3)*zb(j3,j4))*
     .zb(j3,j6))+
     .2._dp*((-s(j1,j2)+s(j3,j4)-s(j5,j6))*za(j2,j4)*zb(j4,j6)-
     .(-s(j1,j2)-s(j3,j4)+s(j5,j6))*za(j2,j5)*zb(j5,j6))))/
     .zb(j5,j6))/
     .(s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s(j5,j
     .6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)))/
     .(2._dp*zb(j2,j4)*(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4)))


      Fsc7=Fsc7+
     .(Lsm1_2mh(s(j3,j4),t(j1,j2,j3),s(j1,j2),s(j5,j6))*za(j2,j3)*zb(j4,
     .j6)**2*
     .t(j1,j2,j3)**2)/
     .((-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))**3*
     .(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4))*zb(j5,j6))+
     .(L0(-t(j1,j2,j3),-s(j5,j6))*za(j2,j4)*zb(j4,j6)**2*t(j1,j2,j3)**2)
     ./
     .(s(j5,j6)*(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))**2*
     .(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4))*zb(j5,j6))+
     .(Lnrat(-s(j3,j4),-s(j5,j6))*((-6._dp*za(j1,j2)*za(j3,j4)*
     .(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3))*
     .(-(za(j1,j5)*zb(j1,j6))-za(j2,j5)*zb(j2,j6))*
     .((-s(j1,j2)-s(j3,j4)+s(j5,j6))*zb(j1,j4)-
     .2._dp*za(j2,j3)*zb(j1,j2)*zb(j3,j4)))/
     .(s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s(j5,j
     .6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)+
     .(za(j4,j5)*(za(j1,j2)*za(j3,j4)*zb(j1,j4)*
     .(-(za(j1,j5)*zb(j1,j3))-za(j2,j5)*zb(j2,j3))+
     .3._dp*(-s(j1,j2)+s(j3,j4)-s(j5,j6))*za(j2,j3)*za(j4,j5)*
     .zb(j3,j4)-za(j2,j3)*za(j3,j4)*
     .(-(za(j1,j5)*zb(j1,j3))-za(j2,j5)*zb(j2,j3))*zb(j3,j4)-
     .2._dp*za(j1,j2)*zb(j1,j3)*
     .((s(j1,j2)-s(j3,j4)-s(j5,j6))*za(j3,j5)+
     .2._dp*za(j3,j4)*za(j5,j6)*zb(j4,j6))))/za(j5,j6)+
     .(za(j3,j4)*zb(j3,j6)*((-(za(j1,j4)*zb(j1,j6))-
     .za(j2,j4)*zb(j2,j6))*
     .(-(za(j1,j2)*zb(j1,j4))+za(j2,j3)*zb(j3,j4))+
     .2._dp*((-s(j1,j2)+s(j3,j4)-s(j5,j6))*za(j2,j4)*zb(j4,j6)-
     .(-s(j1,j2)-s(j3,j4)+s(j5,j6))*za(j2,j5)*zb(j5,j6))))/
     .zb(j5,j6)+(za(j2,j3)*
     .((za(j3,j5)*za(j4,j5)*zb(j3,j4))/za(j5,j6)+
     .(za(j3,j4)*zb(j3,j6)*zb(j4,j6))/zb(j5,j6))*
     .(-s(j1,j2)**2+2._dp*s(j1,j2)*s(j3,j4)-s(j3,j4)**2+
     .2._dp*s(j1,j2)*s(j5,j6)+2._dp*s(j3,j4)*s(j5,j6)-s(j5,j6)**2+
     .(-s(j1,j2)+s(j3,j4)-s(j5,j6))*(t(j1,j2,j3)-t(j1,j2,j4))))/
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))))/
     .(2._dp*(s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s
     .(j5,j6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)*za(j1,j3)*
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4)))-
     .(Lsm1_2mh(s(j3,j4),t(j1,j2,j4),s(j1,j2),s(j5,j6))*za(j3,j5)**2*zb(
     .j1,j4)*
     .t(j1,j2,j4)**2)/
     .(za(j5,j6)*(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))**3*
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4)))-
     .(L0(-t(j1,j2,j4),-s(j5,j6))*za(j3,j5)**2*zb(j1,j3)*t(j1,j2,j4)**2)
     ./
     .(s(j5,j6)*za(j5,j6)*(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))**
     .2*
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4)))+
     .(Lnrat(-s(j3,j4),-s(j5,j6))*((za(j4,j5)*
     .(2._dp*((-s(j1,j2)+s(j3,j4)-s(j5,j6))*za(j3,j5)*zb(j1,j3)+
     .(-s(j1,j2)-s(j3,j4)+s(j5,j6))*za(j5,j6)*zb(j1,j6))+
     .(za(j2,j3)*zb(j1,j2)-za(j3,j4)*zb(j1,j4))*
     .(-(za(j1,j5)*zb(j1,j3))-za(j2,j5)*zb(j2,j3)))*zb(j3,j4))/
     .za(j5,j6)-(6._dp*zb(j1,j2)*
     .((-s(j1,j2)-s(j3,j4)+s(j5,j6))*za(j2,j3)-
     .2._dp*za(j1,j2)*za(j3,j4)*zb(j1,j4))*
     .(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3))*
     .(-(za(j1,j5)*zb(j1,j6))-za(j2,j5)*zb(j2,j6))*zb(j3,j4))/
     .(s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s(j5,j
     .6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)-
     .(zb(j3,j6)*(za(j2,j3)*zb(j1,j2)*
     .(-(za(j1,j4)*zb(j1,j6))-za(j2,j4)*zb(j2,j6))*zb(j3,j4)-
     .za(j3,j4)*zb(j1,j4)*
     .(-(za(j1,j4)*zb(j1,j6))-za(j2,j4)*zb(j2,j6))*zb(j3,j4)-
     .3._dp*(-s(j1,j2)+s(j3,j4)-s(j5,j6))*za(j3,j4)*zb(j1,j4)*
     .zb(j3,j6)+2._dp*za(j2,j4)*zb(j1,j2)*
     .((s(j1,j2)-s(j3,j4)-s(j5,j6))*zb(j4,j6)+
     .2._dp*za(j3,j5)*zb(j3,j4)*zb(j5,j6))))/zb(j5,j6)+
     .(zb(j1,j4)*((za(j3,j5)*za(j4,j5)*zb(j3,j4))/za(j5,j6)+
     .(za(j3,j4)*zb(j3,j6)*zb(j4,j6))/zb(j5,j6))*
     .(-s(j1,j2)**2+2._dp*s(j1,j2)*s(j3,j4)-s(j3,j4)**2+
     .2._dp*s(j1,j2)*s(j5,j6)+2._dp*s(j3,j4)*s(j5,j6)-s(j5,j6)**2+
     .(-s(j1,j2)+s(j3,j4)-s(j5,j6))*(-t(j1,j2,j3)+t(j1,j2,j4))))/
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))))/
     .(2._dp*(s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s
     .(j5,j6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)*zb(j2,j4)*
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4)))+
     .(Ls1(-s(j1,j4),-t(j1,j3,j4),-s(j3,j4),-t(j1,j3,j4))*za(j1,j4)**2*z
     .b(j1,j3)**2*
     .(-(za(j1,j3)*zb(j1,j6))+za(j3,j4)*zb(j4,j6))**2)/
     .(za(j1,j3)*(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4))*zb(j5,j6)*
     .t(j1,j3,j4)**3)-(zb(j1,j3)**2*
     .(za(j1,j3)*zb(j3,j6)+za(j1,j4)*zb(j4,j6))*
     .(-(za(j1,j3)*zb(j1,j6))+za(j3,j4)*zb(j4,j6)))/
     .(2._dp*za(j1,j3)*zb(j1,j4)*(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j
     .4))*
     .zb(j3,j4)*zb(j5,j6)*t(j1,j3,j4))


      Fsc7=Fsc7
     .-(za(j1,j4)*zb(j1,j3)**2*((L1(-t(j1,j3,j4),-s(j3,j4))*za(j3,j4)*
     .(za(j1,j3)*zb(j3,j6)+za(j1,j4)*zb(j4,j6))**2)/
     .(s(j3,j4)**2*(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4)))+
     .(L1(-t(j1,j3,j4),-s(j1,j4))*za(j1,j4)*
     .(-(za(j1,j3)*zb(j1,j6))+za(j3,j4)*zb(j4,j6))**2)/
     .(s(j1,j4)**2*(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4)))))/
     .(2._dp*za(j1,j3)*zb(j5,j6)*t(j1,j3,j4))-
     .(Lsm1_2mh(s(j1,j2),t(j1,j3,j4),s(j3,j4),s(j5,j6))*za(j1,j4)**2*
     .(-(za(j1,j4)*zb(j1,j2))+za(j3,j4)*zb(j2,j3))*zb(j2,j6)**2*t(j1,j3,
     .j4))/
     .(za(j3,j4)*(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4))**3*
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4))*zb(j5,j6))+
     .(L0(-t(j1,j3,j4),-s(j3,j4))*za(j1,j4)**2*zb(j1,j3)*zb(j2,j6)**2*t(
     .j1,j3,j4))/
     .(s(j3,j4)*(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4))**2*
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4))*zb(j5,j6))+
     .(za(j1,j4)*za(j2,j4)*(-(za(j1,j4)*zb(j1,j2))+za(j3,j4)*zb(j2,j3))*
     .zb(j2,j6)**2*((L1(-s(j5,j6),-t(j1,j3,j4))*za(j2,j4))/
     .(za(j1,j4)*t(j1,j3,j4)**2)-
     .(2._dp*L0(-s(j5,j6),-t(j1,j3,j4)))/
     .((-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4))*t(j1,j3,j4)))*
     .t(j1,j3,j4))/
     .(2._dp*za(j3,j4)*(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4))*
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4))*zb(j5,j6))+
     .(Lnrat(-s(j2,j3),-s(j5,j6))*zb(j1,j3)*zb(j4,j6)*
     .(za(j1,j3)*za(j4,j5)+((-(za(j1,j3)*zb(j1,j6))+
     .za(j3,j4)*zb(j4,j6))*t(j1,j2,j3)-
     .(-(za(j1,j3)*zb(j1,j6))-za(j2,j3)*zb(j2,j6))*t(j1,j3,j4))/
     .(zb(j1,j4)*zb(j5,j6))))/
     .(2._dp*(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))*
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4))*
     .(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4)))

      tmp=
     .-((Lsm1_2mh(s(j2,j3),t(j1,j2,j4),s(j1,j4),s(j5,j6))*
     .(za(j2,j3)*zb(j1,j2)-za(j3,j4)*zb(j1,j4))*
     .(-(za(j1,j5)*zb(j1,j2))+za(j4,j5)*zb(j2,j4))**2)/
     .(za(j5,j6)*zb(j2,j4)*
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4))**3))

      tmp=tmp
     .-(L0(-t(j1,j2,j4),-s(j1,j4))*za(j2,j4)*zb(j1,j4)*
     .(-(za(j1,j5)*zb(j1,j2))+za(j4,j5)*zb(j2,j4))**2)/
     .(s(j1,j4)*za(j5,j6)*zb(j2,j4)*
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4))**2)+
     .(za(j2,j5)*((-s(j1,j4)-s(j2,j3)+s(j5,j6))*zb(j1,j2)-
     .2._dp*za(j3,j4)*zb(j1,j4)*zb(j2,j3))*zb(j3,j6))/
     .((s(j1,j4)**2-2._dp*s(j1,j4)*s(j2,j3)+s(j2,j3)**2-
     .2._dp*s(j1,j4)*s(j5,j6)-2._dp*s(j2,j3)*s(j5,j6)+s(j5,j6)**2)*zb(j2,j4)
     .*
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4)))+
     .((-((-s(j1,j4)+s(j2,j3)-s(j5,j6))*za(j2,j3)*zb(j1,j2))-
     .(s(j1,j4)-s(j2,j3)-s(j5,j6))*za(j3,j4)*zb(j1,j4))*
     .((za(j2,j5)**2*zb(j2,j3))/za(j5,j6)+
     .(za(j2,j3)*zb(j3,j6)**2)/zb(j5,j6)))/
     .(2._dp*(s(j1,j4)**2-2._dp*s(j1,j4)*s(j2,j3)+s(j2,j3)**2-
     .2._dp*s(j1,j4)*s(j5,j6)-2._dp*s(j2,j3)*s(j5,j6)+s(j5,j6)**2)*za(j2,j3)
     .*
     .zb(j2,j4)*(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4)))


      tmp=tmp
     .-(Lnrat(-s(j1,j4),-s(j5,j6))*zb(j1,j4)*
     .(((za(j2,j4)*za(j3,j5)+za(j2,j3)*za(j4,j5))*
     .(-(za(j1,j5)*zb(j1,j2))+za(j4,j5)*zb(j2,j4)))/
     .(za(j2,j3)*za(j5,j6)*
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4)))+
     .(6._dp*za(j1,j4)*((-s(j1,j4)-s(j2,j3)+s(j5,j6))*zb(j1,j2)-
     .2._dp*za(j3,j4)*zb(j1,j4)*zb(j2,j3))*
     .(-(za(j1,j2)*zb(j1,j3))-za(j2,j4)*zb(j3,j4))*
     .(-(za(j1,j5)*zb(j1,j6))-za(j4,j5)*zb(j4,j6)))/
     .(s(j1,j4)**2-2._dp*s(j1,j4)*s(j2,j3)+s(j2,j3)**2-
     .2._dp*s(j1,j4)*s(j5,j6)-2._dp*s(j2,j3)*s(j5,j6)+s(j5,j6)**2)**2+
     .(-((za(j1,j4)*za(j2,j5)*zb(j1,j3)*
     .(-(za(j1,j5)*zb(j1,j2))+za(j4,j5)*zb(j2,j4)))/
     .za(j5,j6))-
     .(za(j1,j4)*za(j3,j5)*
     .(-(za(j2,j5)*
     .(2._dp*(s(j1,j4)-s(j2,j3)-s(j5,j6))*zb(j1,j3)+
     .za(j2,j4)*zb(j1,j4)*zb(j2,j3)))+
     .((s(j1,j4)-s(j2,j3)-s(j5,j6))*za(j3,j5)*
     .zb(j1,j2)*
     .(-(za(j1,j2)*zb(j1,j3))-za(j2,j4)*zb(j3,j4))
     .)/(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4))))/(za(j2,j3)*za(j5,
     .j6))
     .+((s(j1,j4)-s(j2,j3)-s(j5,j6))*za(j1,j4)*zb(j1,j2)*
     .(-(za(j2,j5)*zb(j2,j6))+za(j3,j5)*zb(j3,j6)))/
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4))+
     .((s(j1,j4)-s(j2,j3)-s(j5,j6))*za(j2,j5)*za(j3,j4)*
     .(-(za(j1,j5)*zb(j1,j3))+za(j4,j5)*zb(j3,j4)+
     .za(j5,j6)*zb(j3,j6)))/(za(j2,j3)*za(j5,j6))+
     .zb(j3,j6)*(za(j1,j4)*za(j2,j5)*zb(j1,j2)+
     .za(j3,j4)*za(j5,j6)*zb(j3,j6))-
     .4._dp*za(j1,j4)*zb(j2,j6)*
     .(za(j2,j5)*zb(j1,j3)+
     .(za(j2,j3)*za(j5,j6)*zb(j1,j2)*zb(j3,j6))/
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4)))+
     .(zb(j3,j6)*(za(j2,j3)*
     .(-(za(j1,j4)*zb(j1,j2))+za(j3,j4)*zb(j2,j3))*
     .zb(j3,j6)+
     .2._dp*(-((-s(j1,j4)+s(j2,j3)-s(j5,j6))*za(j2,j4)*
     .zb(j2,j6))-
     .(-s(j1,j4)-s(j2,j3)+s(j5,j6))*za(j4,j5)*
     .zb(j5,j6))))/zb(j5,j6))/
     .(s(j1,j4)**2-2._dp*s(j1,j4)*s(j2,j3)+s(j2,j3)**2-
     .2._dp*s(j1,j4)*s(j5,j6)-2._dp*s(j2,j3)*s(j5,j6)+s(j5,j6)**2)))/
     .(2._dp*zb(j2,j4)*(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4)))-
     .(L1(-s(j5,j6),-t(j1,j2,j4))*za(j3,j5)*zb(j1,j3)*zb(j3,j6))/
     .(zb(j2,j4)*(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4))*
     .t(j1,j2,j4))+(L0(-t(j1,j2,j4),-s(j5,j6))*za(j3,j5)*zb(j1,j3)*
     .(-(za(j1,j5)*zb(j1,j2))+za(j4,j5)*zb(j2,j4))*t(j1,j2,j4))/
     .(s(j5,j6)*za(j5,j6)*zb(j2,j4)*
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4))**2)


      tmp=tmp
     .+(Lnrat(-s(j2,j3),-s(j5,j6))*(-((za(j2,j5)*zb(j2,j3)*
     .(2._dp*((-s(j1,j4)+s(j2,j3)-s(j5,j6))*za(j3,j5)*
     .zb(j1,j3)+
     .(-s(j1,j4)-s(j2,j3)+s(j5,j6))*za(j5,j6)*
     .zb(j1,j6))+
     .(za(j2,j3)*zb(j1,j2)-za(j3,j4)*zb(j1,j4))*
     .(-(za(j1,j5)*zb(j1,j3))+za(j4,j5)*zb(j3,j4))))/
     .za(j5,j6))+(6._dp*
     .(-((-s(j1,j4)-s(j2,j3)+s(j5,j6))*za(j3,j4))+
     .2._dp*za(j1,j4)*za(j2,j3)*zb(j1,j2))*zb(j1,j4)*zb(j2,j3)*
     .(-(za(j1,j2)*zb(j1,j3))-za(j2,j4)*zb(j3,j4))*
     .(-(za(j1,j5)*zb(j1,j6))-za(j4,j5)*zb(j4,j6)))/
     .(s(j1,j4)**2-2._dp*s(j1,j4)*s(j2,j3)+s(j2,j3)**2-
     .2._dp*s(j1,j4)*s(j5,j6)-2._dp*s(j2,j3)*s(j5,j6)+s(j5,j6)**2)-
     .(zb(j3,j6)*(3._dp*(-s(j1,j4)+s(j2,j3)-s(j5,j6))*za(j2,j3)*
     .zb(j1,j2)*zb(j3,j6)-
     .za(j2,j3)*zb(j1,j2)*zb(j2,j3)*
     .(-(za(j1,j2)*zb(j1,j6))+za(j2,j4)*zb(j4,j6))+
     .za(j3,j4)*zb(j1,j4)*zb(j2,j3)*
     .(-(za(j1,j2)*zb(j1,j6))+za(j2,j4)*zb(j4,j6))-
     .2._dp*za(j2,j4)*zb(j1,j4)*
     .((s(j1,j4)-s(j2,j3)-s(j5,j6))*zb(j2,j6)-
     .2._dp*za(j3,j5)*zb(j2,j3)*zb(j5,j6))))/zb(j5,j6)+
     .(zb(j1,j2)*(-((za(j2,j5)*za(j3,j5)*zb(j2,j3))/za(j5,j6))-
     .(za(j2,j3)*zb(j2,j6)*zb(j3,j6))/zb(j5,j6))*
     .(-s(j1,j4)**2+2._dp*s(j1,j4)*s(j2,j3)-s(j2,j3)**2+
     .2._dp*s(j1,j4)*s(j5,j6)+2._dp*s(j2,j3)*s(j5,j6)-s(j5,j6)**2+
     .(-s(j1,j4)+s(j2,j3)-s(j5,j6))*
     .(t(j1,j2,j4)-t(j1,j3,j4))))/
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4))))/
     .(2._dp*(s(j1,j4)**2-2._dp*s(j1,j4)*s(j2,j3)+s(j2,j3)**2-
     .2._dp*s(j1,j4)*s(j5,j6)-2._dp*s(j2,j3)*s(j5,j6)+s(j5,j6)**2)*zb(j2,j4)
     .*
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4)))


      tmp=tmp
     .-(I3m(s(j1,j4),s(j2,j3),s(j5,j6))*zb(j1,j4)*
     .((3._dp*za(j1,j4)*(-((-s(j1,j4)+s(j2,j3)-s(j5,j6))*za(j2,j3)*
     .zb(j1,j2))-
     .(s(j1,j4)-s(j2,j3)-s(j5,j6))*za(j3,j4)*zb(j1,j4))*
     .zb(j2,j3)*(-(za(j1,j2)*zb(j1,j3))-za(j2,j4)*zb(j3,j4))*
     .(-(za(j1,j5)*zb(j1,j6))-za(j4,j5)*zb(j4,j6)))/
     .(s(j1,j4)**2-2._dp*s(j1,j4)*s(j2,j3)+s(j2,j3)**2-
     .2._dp*s(j1,j4)*s(j5,j6)-2._dp*s(j2,j3)*s(j5,j6)+s(j5,j6)**2)**2-
     .(za(j2,j4)*(-(za(j1,j5)*zb(j1,j2))+za(j4,j5)*zb(j2,j4))*
     .zb(j3,j6))/t(j1,j2,j4)-
     .(-(za(j2,j4)*((-s(j1,j4)+s(j2,j3)-s(j5,j6))*za(j3,j5)*
     .zb(j2,j3)+
     .(-s(j1,j4)-s(j2,j3)+s(j5,j6))*za(j5,j6)*zb(j2,j6))*
     .zb(j3,j6))+
     .(-(za(j1,j2)*zb(j1,j3))-za(j2,j4)*zb(j3,j4))*
     .(3._dp*za(j1,j4)*za(j3,j5)*zb(j1,j2)*zb(j3,j6)+
     .za(j3,j4)*zb(j2,j3)*
     .(-(za(j1,j5)*zb(j1,j6))-za(j4,j5)*zb(j4,j6)))+
     .za(j1,j4)*za(j2,j5)*zb(j1,j3)*
     .((s(j1,j4)-s(j2,j3)-s(j5,j6))*zb(j2,j6)-
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4))*
     .zb(j3,j6)-2._dp*za(j3,j5)*zb(j2,j3)*zb(j5,j6))-
     .(za(j1,j4)*zb(j1,j2)*zb(j2,j6)*
     .(-(za(j1,j2)*za(j3,j5)*zb(j1,j3))-
     .za(j2,j4)*za(j3,j5)*zb(j3,j4))*
     .(-t(j1,j2,j4)+t(j1,j3,j4)))/
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4)))/
     .(s(j1,j4)**2-2._dp*s(j1,j4)*s(j2,j3)+s(j2,j3)**2-
     .2._dp*s(j1,j4)*s(j5,j6)-2._dp*s(j2,j3)*s(j5,j6)+s(j5,j6)**2)))/
     .(zb(j2,j4)*(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4)))


c --- DSW. Introduce tmp to split up the above expression
      Fsc7=Fsc7
     .+((za(j2,j3)*zb(j1,j2)-za(j3,j4)*zb(j1,j4))*zb(j2,j4)*
     .(tmp))/
     .(zb(j1,j4)*(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4)))


      Fsc7=Fsc7+
     .I3m(s(j1,j2),s(j3,j4),s(j5,j6))*
     .((za(j2,j4)*za(j3,j5)*zb(j1,j2)*zb(j3,j6))/
     .((-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))*
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4)))-
     .(3._dp*za(j5,j6)*(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3))*
     .zb(j2,j6)*(-((za(j1,j4)*zb(j1,j2)*
     .(-(za(j2,j3)*zb(j1,j3))-za(j2,j4)*zb(j1,j4))*
     .(-((s(j1,j2)-s(j3,j4)-s(j5,j6))*za(j1,j2)*zb(j2,j6))+
     .(-s(j1,j2)-s(j3,j4)+s(j5,j6))*za(j1,j5)*zb(j5,j6)))/
     .(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4)))+
     .za(j2,j4)*zb(j1,j2)*
     .(-((s(j1,j2)-s(j3,j4)-s(j5,j6))*za(j1,j2)*zb(j1,j6))-
     .(-s(j1,j2)-s(j3,j4)+s(j5,j6))*za(j2,j5)*zb(j5,j6))))/
     .((s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s(j5,
     .j6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)**2*
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4)))-
     .(3._dp*s(j1,j2)*za(j3,j5)*(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3
     .))*
     .zb(j5,j6)*(za(j5,j6)*zb(j1,j2)*
     .((s(j1,j2)-s(j3,j4)-s(j5,j6))*za(j1,j2)*zb(j1,j6)+
     .(-s(j1,j2)-s(j3,j4)+s(j5,j6))*za(j2,j5)*zb(j5,j6))+
     .(-((s(j1,j2)-s(j3,j4)-s(j5,j6))*za(j2,j5)*zb(j1,j2))-
     .(-s(j1,j2)-s(j3,j4)+s(j5,j6))*za(j5,j6)*zb(j1,j6))*
     .t(j1,j2,j3)))/
     .((s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s(j5,
     .j6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)**2*
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))*
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4)))-
     .(za(j3,j5)*zb(j1,j2)*((za(j1,j2)*za(j3,j4)*zb(j1,j3)+
     .za(j2,j3)*(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3))+
     .za(j2,j4)*(-(za(j1,j4)*zb(j1,j4))-za(j2,j4)*zb(j2,j4)))*
     .zb(j3,j6)*t(j1,j2,j4)-
     .((-(za(j1,j2)*za(j3,j4)*zb(j1,j4))+
     .za(j2,j3)*(-(za(j1,j3)*zb(j1,j3))-
     .za(j2,j3)*zb(j2,j3))+
     .za(j2,j4)*(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))
     .)*(-(za(j1,j4)*zb(j1,j3)*zb(j4,j6))-za(j2,j4)*zb(j2,j3)*zb(j4,j6))
     .*
     .t(j1,j2,j4))/(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))+
     .(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3))*
     .(-((s(j1,j2)-s(j3,j4)-s(j5,j6))*za(j1,j2)*zb(j1,j6))-
     .(-s(j1,j2)-s(j3,j4)+s(j5,j6))*za(j2,j5)*zb(j5,j6)-
     .(-(za(j1,j2)*zb(j1,j6))+za(j2,j4)*zb(j4,j6))*t(j1,j2,j3)+
     .(-(za(j1,j2)*zb(j1,j6))+za(j2,j3)*zb(j3,j6))*t(j1,j2,j4))-
     .za(j1,j2)*zb(j5,j6)*
     .(3._dp*(za(j2,j5)*zb(j1,j2)+za(j4,j5)*zb(j1,j4))*
     .(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3))-
     .za(j4,j5)*zb(j1,j3)*(-t(j1,j2,j3)+t(j1,j2,j4)))))/
     .((s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s(j5,
     .j6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)*
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))*
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4)))+
     .(zb(j2,j6)*(-(za(j2,j4)*(za(j1,j4)*za(j5,j6)*zb(j1,j3)*zb(j1,j6)-
     .(za(j2,j5)*zb(j1,j2)+za(j5,j6)*zb(j1,j6))*
     .(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3))-
     .za(j2,j4)*za(j5,j6)*zb(j1,j2)*zb(j3,j6)))+
     .(za(j1,j4)*(-(za(j2,j3)*zb(j1,j3))-za(j2,j4)*zb(j1,j4))*
     .(za(j1,j5)*zb(j1,j2)*
     .(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3))+
     .3._dp*za(j1,j4)*za(j5,j6)*zb(j1,j3)*zb(j2,j6)-
     .(za(j1,j4)*za(j5,j6)*zb(j2,j3)*zb(j2,j6)*
     .(t(j1,j3,j4)-t(j2,j3,j4)))/
     .(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4))))/
     .(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4))))/
     .((s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s(j5,
     .j6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)*
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4))))


      Fsc7=Fsc7
     .-(Lnrat(-s(j3,j4),-s(j5,j6))*zb(j2,j3)*
     .(-2._dp*(-(za(j1,j4)*zb(j1,j3))+za(j2,j4)*zb(j2,j3))*
     .(-(za(j1,j5)*zb(j1,j6))-za(j2,j5)*zb(j2,j6))+
     .4._dp*(-(za(j1,j2)*za(j4,j5)*zb(j1,j3)*zb(j2,j6))+
     .za(j1,j4)*za(j2,j5)*zb(j1,j2)*zb(j3,j6))+
     .(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3)+
     .(4._dp*s(j5,j6)*za(j1,j4)*zb(j2,j3))/
     .(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4)))*
     .(-((za(j1,j5)*za(j2,j5)*zb(j1,j2))/za(j5,j6))+
     .(za(j1,j2)*zb(j1,j6)*zb(j2,j6))/zb(j5,j6))-
     .(-s(j1,j2)+s(j3,j4)-s(j5,j6))*
     .((za(j1,j5)*za(j4,j5)*zb(j1,j3))/za(j5,j6)+
     .(2._dp*za(j1,j5)*zb(j2,j3)*
     .(za(j1,j5)*za(j2,j4)*zb(j1,j2)+
     .za(j1,j5)*za(j3,j4)*zb(j1,j3)-
     .za(j2,j4)*za(j5,j6)*zb(j2,j6)))/
     .(za(j5,j6)*(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4)))-
     .(za(j2,j4)*zb(j2,j6)*zb(j3,j6))/zb(j5,j6))+
     .(8._dp*s(j1,j2)*za(j1,j5)*za(j4,j5)*zb(j2,j3)*zb(j5,j6))/
     .(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4))+
     .(3._dp*(-s(j1,j2)-s(j3,j4)+s(j5,j6))*
     .(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3))*
     .(-(za(j1,j5)*zb(j1,j6))-za(j2,j5)*zb(j2,j6))*
     .(t(j1,j3,j4)-t(j2,j3,j4)))/
     .(s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s(j5,j
     .6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)))/
     .(2._dp*(s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s
     .(j5,j6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)*zb(j2,j4)*
     .(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4)))


      Fsc7=Fsc7-
     .(Ls1(-s(j2,j3),-t(j2,j3,j4),-s(j3,j4),-t(j2,j3,j4))*za(j2,j4)**2*z
     .b(j2,j3)**2*
     .(-(za(j2,j5)*zb(j2,j4))-za(j3,j5)*zb(j3,j4))**2)/
     .(za(j5,j6)*zb(j2,j4)*(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4))*
     .t(j2,j3,j4)**3)-(za(j2,j4)**2*
     .(za(j3,j5)*zb(j2,j3)+za(j4,j5)*zb(j2,j4))*
     .(-(za(j2,j5)*zb(j2,j4))-za(j3,j5)*zb(j3,j4)))/
     .(2._dp*za(j2,j3)*za(j3,j4)*za(j5,j6)*zb(j2,j4)*
     .(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4))*t(j2,j3,j4))


      Fsc7=Fsc7
     .+(za(j2,j4)**2*zb(j2,j3)*(-((L1(-t(j2,j3,j4),-s(j3,j4))*
     .(za(j3,j5)*zb(j2,j3)+za(j4,j5)*zb(j2,j4))**2*zb(j3,j4))/
     .(s(j3,j4)**2*(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4))))+
     .(L1(-t(j2,j3,j4),-s(j2,j3))*zb(j2,j3)*
     .(-(za(j2,j5)*zb(j2,j4))-za(j3,j5)*zb(j3,j4))**2)/
     .(s(j2,j3)**2*(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4)))))/
     .(2._dp*za(j5,j6)*zb(j2,j4)*t(j2,j3,j4))


      Fsc7=Fsc7-
     .(L0(-t(j2,j3,j4),-s(j3,j4))*za(j1,j5)**2*za(j2,j4)*zb(j2,j3)**2*t(
     .j2,j3,j4))/
     .(s(j3,j4)*za(j5,j6)*(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4))**
     .2*
     .(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4)))


      Fsc7=Fsc7-
     .(Lsm1_2mh(s(j1,j2),t(j2,j3,j4),s(j3,j4),s(j5,j6))*za(j1,j5)**2*zb(
     .j2,j3)**2*
     .(za(j1,j2)*zb(j2,j3)-za(j1,j4)*zb(j3,j4))*t(j2,j3,j4))/
     .(za(j5,j6)*(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4))**3*zb(j3,j
     .4)*
     .(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4)))


      Fsc7=Fsc7
     .+(za(j1,j5)**2*zb(j1,j3)*zb(j2,j3)*
     .(za(j1,j2)*zb(j2,j3)-za(j1,j4)*zb(j3,j4))*
     .((L1(-s(j5,j6),-t(j2,j3,j4))*zb(j1,j3))/(zb(j2,j3)*t(j2,j3,j4)**2)
     .-
     .(2._dp*L0(-s(j5,j6),-t(j2,j3,j4)))/
     .((-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4))*t(j2,j3,j4)))*
     .t(j2,j3,j4))/
     .(2._dp*za(j5,j6)*(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4))*zb(j3,
     .j4)*
     .(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4)))


      Fsc7=Fsc7
     .-(Lnrat(-s(j1,j2),-s(j5,j6))*zb(j2,j3)*
     .(((s(j1,j2)-s(j3,j4)-s(j5,j6))*zb(j1,j2)*
     .(-(za(j2,j5)*(-(za(j1,j5)*za(j2,j4))+za(j1,j2)*za(j4,j5))*
     .zb(j2,j3))-za(j1,j5)*za(j2,j5)*
     .(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3))+
     .(za(j1,j4)*za(j1,j5)**2*
     .(-(za(j2,j3)*zb(j1,j3))-za(j2,j4)*zb(j1,j4))*zb(j2,j3))/
     .(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4))))/
     .((s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-
     .2._dp*s(j1,j2)*s(j5,j6)-2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)*za(j5,j6)
     .)
     .-(2._dp*(-s(j1,j2)-s(j3,j4)+s(j5,j6))*za(j1,j2)*za(j4,j5)*
     .(zb(j1,j6)*zb(j2,j3)+zb(j1,j3)*zb(j2,j6)))/
     .(s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s(j5,j
     .6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)-
     .(za(j1,j4)*zb(j2,j3)*(-((za(j1,j5)*za(j2,j5)*zb(j1,j2))/
     .za(j5,j6))-(za(j1,j2)*zb(j1,j6)*zb(j2,j6))/zb(j5,j6)))/
     .(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4))-
     .(za(j2,j4)*zb(j2,j6)*zb(j3,j6))/zb(j5,j6)+
     .((s(j1,j2)-s(j3,j4)-s(j5,j6))*za(j1,j2)*
     .(zb(j1,j3)*zb(j2,j6)*
     .(-(za(j1,j4)*zb(j1,j6))-za(j2,j4)*zb(j2,j6))-
     .za(j1,j4)*zb(j2,j3)*
     .(zb(j1,j6)**2+((-(za(j2,j3)*zb(j1,j3))-
     .za(j2,j4)*zb(j1,j4))*zb(j2,j6)**2)/
     .(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4)))+
     .zb(j1,j2)*zb(j3,j6)*
     .(-(za(j2,j4)*zb(j2,j6))-za(j3,j4)*zb(j3,j6))))/
     .((s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-
     .2._dp*s(j1,j2)*s(j5,j6)-2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)*zb(j5,j6)
     .)
     .+(6._dp*s(j1,j2)*s(j3,j4)*(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3
     .))*
     .(-(za(j1,j5)*zb(j1,j6))-za(j2,j5)*zb(j2,j6))*
     .(t(j1,j3,j4)-t(j2,j3,j4)))/
     .(s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s(j5,j
     .6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)**2-
     .(s(j1,j2)*(-((za(j4,j5)**2*zb(j3,j4))/za(j5,j6))-
     .(za(j3,j4)*zb(j3,j6)**2)/zb(j5,j6))*t(j2,j3,j4))/
     .(s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s(j5,j
     .6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)))/
     .(2._dp*s(j3,j4)*zb(j2,j4)*(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4
     .)))


      Fsc7=Fsc7-
     .(Lnrat(-s(j1,j2),-s(j5,j6))*za(j1,j4)*
     .((za(j1,j5)*za(j4,j5)*zb(j1,j3))/za(j5,j6)+
     .((s(j1,j2)-s(j3,j4)-s(j5,j6))*zb(j1,j2)*
     .(za(j1,j5)*za(j2,j4)*
     .(-(za(j1,j5)*zb(j1,j3))-za(j2,j5)*zb(j2,j3))-
     .za(j1,j4)*zb(j2,j3)*
     .(za(j2,j5)**2+(za(j1,j5)**2*
     .(-(za(j2,j3)*zb(j1,j3))-za(j2,j4)*zb(j1,j4)))/
     .(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4)))-
     .za(j1,j2)*za(j4,j5)*
     .(-(za(j1,j5)*zb(j1,j3))+za(j4,j5)*zb(j3,j4))))/
     .((s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-
     .2._dp*s(j1,j2)*s(j5,j6)-2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)*za(j5,j6)
     .)
     .+(2._dp*(-s(j1,j2)-s(j3,j4)+s(j5,j6))*
     .(za(j1,j5)*za(j2,j4)+za(j1,j4)*za(j2,j5))*zb(j1,j2)*zb(j3,j6)
     .)/(s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s(j5
     .,j6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)-
     .(za(j1,j4)*zb(j2,j3)*(-((za(j1,j5)*za(j2,j5)*zb(j1,j2))/
     .za(j5,j6))-(za(j1,j2)*zb(j1,j6)*zb(j2,j6))/zb(j5,j6)))/
     .(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4))+
     .((s(j1,j2)-s(j3,j4)-s(j5,j6))*za(j1,j2)*
     .(-(zb(j1,j6)*(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3))*
     .zb(j2,j6))+(za(j1,j4)*
     .(-(za(j2,j3)*zb(j1,j3))-za(j2,j4)*zb(j1,j4))*
     .zb(j2,j3)*zb(j2,j6)**2)/
     .(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4))-
     .za(j1,j4)*zb(j1,j6)*
     .(-(zb(j1,j3)*zb(j2,j6))-zb(j1,j2)*zb(j3,j6))))/
     .((s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-
     .2._dp*s(j1,j2)*s(j5,j6)-2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)*zb(j5,j6)
     .)
     .-(s(j1,j2)*(-((za(j4,j5)**2*zb(j3,j4))/za(j5,j6))-
     .(za(j3,j4)*zb(j3,j6)**2)/zb(j5,j6))*t(j1,j3,j4))/
     .(s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s(j5,j
     .6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)+
     .(6._dp*s(j1,j2)*s(j3,j4)*(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3)
     .)*
     .(-(za(j1,j5)*zb(j1,j6))-za(j2,j5)*zb(j2,j6))*
     .(-t(j1,j3,j4)+t(j2,j3,j4)))/
     .(s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s(j5,j
     .6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)**2))/
     .(2._dp*s(j3,j4)*za(j1,j3)*(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4
     .)))


      Fsc7=Fsc7
     .-(Lnrat(-s(j3,j4),-s(j5,j6))*za(j1,j4)*
     .(-2._dp*(za(j1,j4)*zb(j1,j3)-za(j2,j4)*zb(j2,j3))*
     .(-(za(j1,j5)*zb(j1,j6))-za(j2,j5)*zb(j2,j6))-
     .(8._dp*s(j1,j2)*za(j1,j4)*za(j5,j6)*zb(j2,j6)*zb(j3,j6))/
     .(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4))+
     .4._dp*(-(za(j1,j2)*za(j4,j5)*zb(j1,j6)*zb(j2,j3))+
     .za(j1,j5)*za(j2,j4)*zb(j1,j2)*zb(j3,j6))+
     .(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3)+
     .(4._dp*s(j5,j6)*za(j1,j4)*zb(j2,j3))/
     .(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4)))*
     .((za(j1,j5)*za(j2,j5)*zb(j1,j2))/za(j5,j6)-
     .(za(j1,j2)*zb(j1,j6)*zb(j2,j6))/zb(j5,j6))-
     .(-s(j1,j2)+s(j3,j4)-s(j5,j6))*
     .((za(j1,j5)*za(j4,j5)*zb(j1,j3))/za(j5,j6)-
     .(za(j2,j4)*zb(j2,j6)*zb(j3,j6))/zb(j5,j6)-
     .(2._dp*za(j1,j4)*zb(j2,j6)*
     .(-(za(j1,j2)*zb(j1,j3)*zb(j2,j6))-
     .za(j2,j4)*zb(j2,j6)*zb(j3,j4)+
     .za(j1,j5)*zb(j1,j3)*zb(j5,j6)))/
     .((-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4))*zb(j5,j6)))+
     .(3._dp*(-s(j1,j2)-s(j3,j4)+s(j5,j6))*
     .(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3))*
     .(-(za(j1,j5)*zb(j1,j6))-za(j2,j5)*zb(j2,j6))*
     .(-t(j1,j3,j4)+t(j2,j3,j4)))/
     .(s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s(j5,j
     .6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)))/
     .(2._dp*(s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s
     .(j5,j6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)*za(j1,j3)*
     .(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4)))


      Fsc7=Fsc7
     .+(Lnrat(-s(j1,j4),-s(j5,j6))*za(j2,j4)*za(j3,j5)*
     .(zb(j2,j4)*zb(j3,j6)-((-(za(j2,j5)*zb(j2,j4))-
     .za(j3,j5)*zb(j3,j4))*t(j1,j2,j4)-
     .(-(za(j1,j5)*zb(j1,j4))-za(j2,j5)*zb(j2,j4))*t(j2,j3,j4))/
     .(za(j2,j3)*za(j5,j6))))/
     .(2._dp*(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))*
     .(-(za(j1,j3)*zb(j1,j2))-za(j3,j4)*zb(j2,j4))*
     .(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4)))


      tmp=
     .(za(j4,j5)*zb(j1,j6)*(-((-s(j1,j4)-s(j2,j3)+s(j5,j6))*
     .za(j1,j2))+2._dp*za(j1,j4)*za(j2,j3)*zb(j3,j4)))/
     .((s(j1,j4)**2-2._dp*s(j1,j4)*s(j2,j3)+s(j2,j3)**2-
     .2._dp*s(j1,j4)*s(j5,j6)-2._dp*s(j2,j3)*s(j5,j6)+s(j5,j6)**2)*za(j1,j3)
     .*
     .(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4)))


      tmp=tmp
     .+(((s(j1,j4)-s(j2,j3)-s(j5,j6))*za(j1,j2)*zb(j1,j4)+
     .(-s(j1,j4)+s(j2,j3)-s(j5,j6))*za(j2,j3)*zb(j3,j4))*
     .(-((za(j4,j5)**2*zb(j1,j4))/za(j5,j6))-
     .(za(j1,j4)*zb(j1,j6)**2)/zb(j5,j6)))/
     .(2._dp*(s(j1,j4)**2-2._dp*s(j1,j4)*s(j2,j3)+s(j2,j3)**2-
     .2._dp*s(j1,j4)*s(j5,j6)-2._dp*s(j2,j3)*s(j5,j6)+s(j5,j6)**2)*za(j1,j3)
     .*
     .zb(j1,j4)*(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4)))


      tmp=tmp
     .+(L0(-t(j1,j2,j3),-s(j2,j3))*za(j2,j3)*zb(j1,j3)*
     .(za(j1,j2)*zb(j2,j6)+za(j1,j3)*zb(j3,j6))**2)/
     .(s(j2,j3)*za(j1,j3)*(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4))**2*
     .zb(j5,j6))


      tmp=tmp
     .+(Lsm1_2mh(s(j1,j4),t(j1,j2,j3),s(j2,j3),s(j5,j6))*
     .(-(za(j1,j2)*zb(j1,j4))+za(j2,j3)*zb(j3,j4))*
     .(za(j1,j2)*zb(j2,j6)+za(j1,j3)*zb(j3,j6))**2)/
     .(za(j1,j3)*(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4))**3*
     .zb(j5,j6))


      tmp=tmp
     .-(Lnrat(-s(j2,j3),-s(j5,j6))*za(j2,j3)*
     .((6._dp*(za(j2,j4)*zb(j1,j2)+za(j3,j4)*zb(j1,j3))*zb(j2,j3)*
     .(-((-s(j1,j4)-s(j2,j3)+s(j5,j6))*za(j1,j2))+
     .2._dp*za(j1,j4)*za(j2,j3)*zb(j3,j4))*
     .(-(za(j2,j5)*zb(j2,j6))-za(j3,j5)*zb(j3,j6)))/
     .(s(j1,j4)**2-2._dp*s(j1,j4)*s(j2,j3)+s(j2,j3)**2-
     .2._dp*s(j1,j4)*s(j5,j6)-2._dp*s(j2,j3)*s(j5,j6)+s(j5,j6)**2)**2-
     .((za(j1,j2)*zb(j2,j6)+za(j1,j3)*zb(j3,j6))*
     .(zb(j1,j4)*zb(j3,j6)+zb(j1,j3)*zb(j4,j6)))/
     .(zb(j1,j4)*(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4))*
     .zb(j5,j6))+(-((za(j4,j5)*
     .(za(j4,j5)*zb(j1,j4)*
     .(za(j1,j2)*zb(j2,j3)-za(j1,j4)*zb(j3,j4))+
     .2._dp*(-((s(j1,j4)-s(j2,j3)-s(j5,j6))*za(j1,j5)*
     .zb(j1,j3))+
     .(-s(j1,j4)-s(j2,j3)+s(j5,j6))*za(j5,j6)*
     .zb(j3,j6))))/za(j5,j6))-
     .((-s(j1,j4)+s(j2,j3)-s(j5,j6))*za(j1,j2)*zb(j2,j3)*
     .(-(za(j1,j5)*zb(j1,j6))+za(j4,j5)*zb(j4,j6)))/
     .(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4))+
     .(za(j2,j4)*zb(j1,j6)*zb(j2,j3)*
     .(za(j1,j2)*zb(j2,j6)+za(j1,j3)*zb(j3,j6)))/
     .zb(j5,j6)+(zb(j2,j3)*zb(j4,j6)*
     .(-((2._dp*(-s(j1,j4)+s(j2,j3)-s(j5,j6))*za(j2,j4)+
     .za(j1,j4)*za(j2,j3)*zb(j1,j3))*zb(j1,j6))-
     .((-s(j1,j4)+s(j2,j3)-s(j5,j6))*za(j1,j2)*
     .(za(j2,j4)*zb(j1,j2)+za(j3,j4)*zb(j1,j3))*
     .zb(j4,j6))/
     .(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4))))/
     .(zb(j1,j4)*zb(j5,j6))+
     .((-s(j1,j4)+s(j2,j3)-s(j5,j6))*zb(j1,j6)*zb(j3,j4)*
     .(-(za(j2,j4)*zb(j2,j6))-za(j3,j4)*zb(j3,j6)-
     .za(j4,j5)*zb(j5,j6)))/(zb(j1,j4)*zb(j5,j6))+
     .za(j4,j5)*(-(za(j1,j2)*zb(j1,j6)*zb(j2,j3))+
     .za(j4,j5)*zb(j3,j4)*zb(j5,j6))-
     .4._dp*za(j1,j5)*zb(j2,j3)*
     .(za(j2,j4)*zb(j1,j6)+
     .(za(j1,j2)*za(j4,j5)*zb(j1,j4)*zb(j5,j6))/
     .(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4))))/
     .(s(j1,j4)**2-2._dp*s(j1,j4)*s(j2,j3)+s(j2,j3)**2-
     .2._dp*s(j1,j4)*s(j5,j6)-2._dp*s(j2,j3)*s(j5,j6)+s(j5,j6)**2)))/
     .(2._dp*za(j1,j3)*(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4)))


      tmp=tmp
     .-(L1(-s(j5,j6),-t(j1,j2,j3))*za(j2,j4)*za(j4,j5)*zb(j4,j6))/
     .(za(j1,j3)*(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4))*t(j1,j2,j3))


      tmp=tmp
     .-(L0(-t(j1,j2,j3),-s(j5,j6))*za(j2,j4)*
     .(za(j1,j2)*zb(j2,j6)+za(j1,j3)*zb(j3,j6))*zb(j4,j6)*
     .t(j1,j2,j3))/
     .(s(j5,j6)*za(j1,j3)*(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4))**2*
     .zb(j5,j6))


      tmp=tmp
     .+(Lnrat(-s(j1,j4),-s(j5,j6))*
     .((6._dp*za(j1,j4)*za(j2,j3)*
     .(za(j2,j4)*zb(j1,j2)+za(j3,j4)*zb(j1,j3))*
     .(-2._dp*za(j1,j2)*zb(j1,j4)*zb(j2,j3)+
     .(-s(j1,j4)-s(j2,j3)+s(j5,j6))*zb(j3,j4))*
     .(-(za(j2,j5)*zb(j2,j6))-za(j3,j5)*zb(j3,j6)))/
     .(s(j1,j4)**2-2._dp*s(j1,j4)*s(j2,j3)+s(j2,j3)**2-
     .2._dp*s(j1,j4)*s(j5,j6)-2._dp*s(j2,j3)*s(j5,j6)+s(j5,j6)**2)+
     .(za(j4,j5)*(-3._dp*(s(j1,j4)-s(j2,j3)-s(j5,j6))*za(j1,j2)*
     .za(j4,j5)*zb(j1,j4)+
     .za(j1,j2)*za(j1,j4)*
     .(za(j2,j5)*zb(j1,j2)+za(j3,j5)*zb(j1,j3))*
     .zb(j1,j4)-
     .za(j1,j4)*za(j2,j3)*
     .(za(j2,j5)*zb(j1,j2)+za(j3,j5)*zb(j1,j3))*
     .zb(j3,j4)-
     .2._dp*za(j2,j3)*zb(j1,j3)*
     .((-s(j1,j4)+s(j2,j3)-s(j5,j6))*za(j1,j5)+
     .2._dp*za(j1,j4)*za(j5,j6)*zb(j4,j6))))/za(j5,j6)+
     .(za(j1,j4)*zb(j1,j6)*
     .((-(za(j1,j2)*zb(j1,j4))+za(j2,j3)*zb(j3,j4))*
     .(-(za(j2,j4)*zb(j2,j6))-za(j3,j4)*zb(j3,j6))+
     .2._dp*((s(j1,j4)-s(j2,j3)-s(j5,j6))*za(j2,j4)*
     .zb(j4,j6)-
     .(-s(j1,j4)-s(j2,j3)+s(j5,j6))*za(j2,j5)*zb(j5,j6))
     .))/zb(j5,j6)-(za(j1,j2)*((za(j1,j5)*za(j4,j5)*zb(j1,j4))/za(j5,j6)
     .+
     .(za(j1,j4)*zb(j1,j6)*zb(j4,j6))/zb(j5,j6))*
     .(-s(j1,j4)**2+2._dp*s(j1,j4)*s(j2,j3)-s(j2,j3)**2+
     .2._dp*s(j1,j4)*s(j5,j6)+2._dp*s(j2,j3)*s(j5,j6)-s(j5,j6)**2+
     .(s(j1,j4)-s(j2,j3)-s(j5,j6))*(t(j1,j2,j3)-t(j2,j3,j4))
     .))/(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4))))/
     .(2._dp*(s(j1,j4)**2-2._dp*s(j1,j4)*s(j2,j3)+s(j2,j3)**2-
     .2._dp*s(j1,j4)*s(j5,j6)-2._dp*s(j2,j3)*s(j5,j6)+s(j5,j6)**2)*za(j1,j3)
     .*
     .(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4)))


      tmp=tmp
     .-(I3m(s(j2,j3),s(j1,j4),s(j5,j6))*za(j2,j3)*
     .((3._dp*za(j1,j4)*(za(j2,j4)*zb(j1,j2)+za(j3,j4)*zb(j1,j3))*
     .zb(j2,j3)*((s(j1,j4)-s(j2,j3)-s(j5,j6))*za(j1,j2)*
     .zb(j1,j4)+
     .(-s(j1,j4)+s(j2,j3)-s(j5,j6))*za(j2,j3)*zb(j3,j4))*
     .(-(za(j2,j5)*zb(j2,j6))-za(j3,j5)*zb(j3,j6)))/
     .(s(j1,j4)**2-2._dp*s(j1,j4)*s(j2,j3)+s(j2,j3)**2-
     .2._dp*s(j1,j4)*s(j5,j6)-2._dp*s(j2,j3)*s(j5,j6)+s(j5,j6)**2)**2-
     .(za(j4,j5)*zb(j1,j3)*
     .(za(j1,j2)*zb(j2,j6)+za(j1,j3)*zb(j3,j6)))/t(j1,j2,j3)-
     .(za(j2,j4)*zb(j1,j6)*zb(j2,j3)*
     .((-s(j1,j4)+s(j2,j3)-s(j5,j6))*za(j1,j5)-
     .za(j4,j5)*
     .(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4))+
     .2._dp*za(j1,j4)*za(j5,j6)*zb(j4,j6))+
     .(za(j2,j4)*zb(j1,j2)+za(j3,j4)*zb(j1,j3))*
     .(-(za(j1,j4)*zb(j3,j4)*
     .(-(za(j2,j5)*zb(j2,j6))-za(j3,j5)*zb(j3,j6)))-
     .3._dp*za(j1,j2)*za(j4,j5)*zb(j2,j3)*zb(j4,j6))-
     .za(j4,j5)*zb(j1,j3)*
     .((s(j1,j4)-s(j2,j3)-s(j5,j6))*za(j1,j4)*zb(j4,j6)-
     .(-s(j1,j4)-s(j2,j3)+s(j5,j6))*za(j1,j5)*zb(j5,j6))+
     .(za(j1,j2)*za(j1,j5)*zb(j2,j3)*
     .(za(j2,j4)*zb(j1,j2)*zb(j4,j6)+
     .za(j3,j4)*zb(j1,j3)*zb(j4,j6))*
     .(-t(j1,j2,j3)+t(j2,j3,j4)))/
     .(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4)))/
     .(s(j1,j4)**2-2._dp*s(j1,j4)*s(j2,j3)+s(j2,j3)**2-
     .2._dp*s(j1,j4)*s(j5,j6)-2._dp*s(j2,j3)*s(j5,j6)+s(j5,j6)**2)))/
     .(za(j1,j3)*(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4)))


c --- DSW. Introduce tmp to split up the above expression
      Fsc7=Fsc7
     .+(za(j1,j3)*(-(za(j1,j2)*zb(j1,j4))+za(j2,j3)*zb(j3,j4))*
     .(tmp))/
     .(za(j2,j3)*(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4)))


      Fsc7=Fsc7
     .+I3m(s(j1,j2),s(j3,j4),s(j5,j6))
     .*(-((za(j1,j2)*za(j4,j5)*zb(j1,j3)*zb(j4,j6))/
     .((-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))*
     .(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4))))
     .+
     .(3._dp*za(j1,j5)*(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3))*
     .(-(za(j1,j2)*zb(j1,j3)*
     .((s(j1,j2)-s(j3,j4)-s(j5,j6))*za(j2,j5)*zb(j1,j2)+
     .(-s(j1,j2)-s(j3,j4)+s(j5,j6))*za(j5,j6)*zb(j1,j6)))+
     .(za(j1,j2)*(-(za(j2,j3)*zb(j1,j3))-za(j2,j4)*zb(j1,j4))*
     .zb(j2,j3)*((s(j1,j2)-s(j3,j4)-s(j5,j6))*za(j1,j5)*
     .zb(j1,j2)-(-s(j1,j2)-s(j3,j4)+s(j5,j6))*za(j5,j6)*
     .zb(j2,j6)))/(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4))
     .)*zb(j5,j6))/((s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-
     .2._dp*s(j1,j2)*s(j5,j6)-2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)**2*
     .(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4)))
     .+
     .(3._dp*s(j1,j2)*za(j5,j6)*(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3
     .))*
     .zb(j4,j6)*(za(j1,j2)*(-((s(j1,j2)-s(j3,j4)-s(j5,j6))*za(j2,j5)*
     .zb(j1,j2))-
     .(-s(j1,j2)-s(j3,j4)+s(j5,j6))*za(j5,j6)*zb(j1,j6))*zb(j5,j6)
     .+((s(j1,j2)-s(j3,j4)-s(j5,j6))*za(j1,j2)*zb(j1,j6)+
     .(-s(j1,j2)-s(j3,j4)+s(j5,j6))*za(j2,j5)*zb(j5,j6))*t(j1,j2,j4)
     .))/((s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s(
     .j5,j6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)**2*
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))*
     .(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4)))
     .+
     .(za(j1,j2)*zb(j4,j6)*(-(((-(za(j1,j4)*za(j3,j5)*zb(j1,j3))-
     .za(j2,j4)*za(j3,j5)*zb(j2,j3))*
     .(zb(j1,j3)*(-(za(j1,j3)*zb(j1,j4))-
     .za(j2,j3)*zb(j2,j4))+
     .zb(j1,j4)*(-(za(j1,j4)*zb(j1,j4))-
     .za(j2,j4)*zb(j2,j4))-za(j2,j3)*zb(j1,j2)*zb(j3,j4)
     .)*t(j1,j2,j3))/(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4)))+
     .za(j4,j5)*(zb(j1,j3)*
     .(-(za(j1,j3)*zb(j1,j3))-za(j2,j3)*zb(j2,j3))+
     .zb(j1,j4)*(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3))+
     .za(j2,j4)*zb(j1,j2)*zb(j3,j4))*t(j1,j2,j3)-
     .za(j5,j6)*zb(j1,j2)*
     .(3._dp*(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3))*
     .(-(za(j1,j2)*zb(j1,j6))+za(j2,j3)*zb(j3,j6))-
     .za(j2,j4)*zb(j3,j6)*(t(j1,j2,j3)-t(j1,j2,j4)))+
     .(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3))*
     .((s(j1,j2)-s(j3,j4)-s(j5,j6))*za(j2,j5)*zb(j1,j2)+
     .(-s(j1,j2)-s(j3,j4)+s(j5,j6))*za(j5,j6)*zb(j1,j6)+
     .(za(j2,j5)*zb(j1,j2)+za(j4,j5)*zb(j1,j4))*t(j1,j2,j3)-
     .(za(j2,j5)*zb(j1,j2)+za(j3,j5)*zb(j1,j3))*t(j1,j2,j4))))/
     .((s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s(j5,
     .j6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)*
     .(-(za(j1,j3)*zb(j1,j4))-za(j2,j3)*zb(j2,j4))*
     .(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4)))
     .+
     .(za(j1,j5)*(-(zb(j1,j3)*(-(za(j1,j2)*za(j4,j5)*zb(j1,j3)*zb(j5,j6)
     .)-
     .za(j2,j4)*za(j2,j5)*zb(j2,j3)*zb(j5,j6)-
     .(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3))*
     .(-(za(j1,j2)*zb(j1,j6))-za(j2,j5)*zb(j5,j6))))+
     .((-(za(j2,j3)*zb(j1,j3))-za(j2,j4)*zb(j1,j4))*zb(j2,j3)*
     .(-(za(j1,j2)*(-(za(j1,j4)*zb(j1,j3))-za(j2,j4)*zb(j2,j3))*
     .zb(j2,j6))-3._dp*za(j1,j5)*za(j2,j4)*zb(j2,j3)*zb(j5,j6)+
     .(za(j1,j4)*za(j1,j5)*zb(j2,j3)*zb(j5,j6)*
     .(-t(j1,j3,j4)+t(j2,j3,j4)))/
     .(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4))))/
     .(-(za(j1,j3)*zb(j2,j3))-za(j1,j4)*zb(j2,j4))))/
     .((s(j1,j2)**2-2._dp*s(j1,j2)*s(j3,j4)+s(j3,j4)**2-2._dp*s(j1,j2)*s(j5,
     .j6)-
     .2._dp*s(j3,j4)*s(j5,j6)+s(j5,j6)**2)*
     .(za(j1,j2)*zb(j2,j4)+za(j1,j3)*zb(j3,j4))))

      return 
      end
