!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      function D3six(k1,k2,k3,k4,k5,k6)
        use mod_qcdloop_c
      implicit none
      include 'src/Inc/types.f'
      complex(dp):: D3six
      
C----- six dimensional box corresponding to 
C----- qlI4(s56,0._dp,s34,0._dp,s156,s134,0._dp,mtsq,mtsq,0._dp,musq,e)
C----- multiplied by a factor of -C(0)/2
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/cplx.h'
      include 'src/Inc/masses.f'
      include 'src/Inc/scale.f'
      include 'src/Inc/sprods_com.f'
      integer:: k1,k2,k3,k4,k5,k6
      complex(dp):: IntC(4),IntD
      real(dp):: s12,s34,s56,s134,s156,C(0:4),mtsq,Delta
      integer:: e
      mtsq=mt**2
      s12=s(k1,k2)
      s34=s(k3,k4)
      s56=s(k5,k6)
      s134=s(k1,k3)+s(k1,k4)+s(k3,k4)
      s156=s(k1,k5)+s(k1,k6)+s(k5,k6)
      Delta=s12*mtsq-s34*s56+s134*s156
      C(1)=2._dp*(s134-s34)*(2._dp*s12*mtsq-Delta)/Delta**2
      C(2)=2._dp*(s34-s156)/Delta
      C(3)=2._dp*(s56-s134)/Delta
      C(4)=2._dp*(s156-s56)*(2._dp*s12*mtsq-Delta)/Delta**2
      C(0)=4._dp*s12*(s134*s156-s34*s56)/Delta**2
      e=0
      IntC(1)=qlI3(s134,0._dp,s34,0._dp,mtsq,mtsq,musq,e)    !C7
      IntC(2)=qlI3(0._dp,s34,s156,0._dp,0._dp,mtsq,musq,e)     !C5
      IntC(3)=qlI3(0._dp,s56,s134,0._dp,0._dp,mtsq,musq,e)     !C3
      IntC(4)=qlI3(s156,0._dp,s56,0._dp,mtsq,mtsq,musq,e)    !C9
      IntD=qlI4(s56,0._dp,s34,0._dp,s156,s134,0._dp,mtsq,mtsq,0._dp,musq,e)
      D3six=0.5_dp*(C(1)*IntC(1)+C(2)*IntC(2)+C(3)*IntC(3)+C(4)*IntC(4)
     & +2._dp*IntD)

C---debug
c---real six dim box
c      D3six=-(C(1)*IntC(1)+C(2)*IntC(2)+C(3)*IntC(3)+C(4)*IntC(4)
c     & +2._dp*IntD)/C(0)
C---debug
      return
      end

