!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine qqb_w_tndk(p,msq)
      implicit none
      include 'src/Inc/types.f'
      
c----Matrix element for W production
C----averaged over initial colours and spins
C for nwz=+1
c     f(-p1)+f(-p2)--> W^+(n(p3)+e^+(p4))   + tbar(p5)
C For nwz=-1
c     f(-p1)+f(-p2)--> W^-(e^-(p3)+nbar(p4))+ t(p5) 
c---
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/cplx.h'
      include 'src/Inc/ewcouple.f'
      include 'src/Inc/nwz.f'
      include 'src/Inc/qcdcouple.f'
      include 'src/Inc/sprods_com.f'
      integer:: j,k
      real(dp):: msq(-nf:nf,-nf:nf),p(mxpart,4),fac
      real(dp):: qgWq,qbgWqb,gqbWqb,gqWq,w1cjet

      msq(:,:)=zero

C--setup s products through common block
      call dotem(5,p,s)

      fac=gwsq**2*gsq*V

      if     (nwz == -1) then
c---- basic process is g+b -> W- + t      
        qgWq=  -aveqg*fac*w1cjet(1,5,3,4,2)
        gqWq=  -aveqg*fac*w1cjet(2,5,3,4,1)
      elseif (nwz == +1) then
c---- basic process is g+b~ -> W+ + t~      
        gqbWqb=-aveqg*fac*w1cjet(2,5,4,3,1)
        qbgWqb=-aveqg*fac*w1cjet(1,5,4,3,2)
      else
        write(6,*) 'Problem with nwz in qqb_w_tndk.f: nwz=',nwz
        stop
      endif
      
      do j=-nf,nf,nf
      do k=-nf,nf,nf
      if     ((j == +5) .and. (k == 0) .and. (nwz == -1)) then
          msq(j,k)=qgWq
      elseif ((j == -5) .and. (k == 0) .and. (nwz == +1)) then
          msq(j,k)=qbgWqb
      elseif ((j == 0) .and. (k == +5) .and. (nwz == -1)) then
          msq(j,k)=gqWq
      elseif ((j == 0) .and. (k == -5) .and. (nwz == +1)) then
          msq(j,k)=gqbWqb
      endif

      enddo
      enddo
      return
      end
 
