!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      function aqmmC4x123(p1,p2,p3,p4,za,zb,msqCoeff)
      implicit none
      include 'src/Inc/types.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/zprods_decl.f'
      include 'src/ggHgg_mass/mtsq.f'
      integer p1,p2,p3,p4
      complex(dp):: aqmmC4x123,aqmmC4x123m0,aqmmC4x123m2,msqCoeff
      msqCoeff=aqmmC4x123m2(p1,p2,p3,p4,za,zb)
      aqmmC4x123=aqmmC4x123m0(p1,p2,p3,p4,za,zb)+mtsq*msqCoeff
      return
      end

      function aqmmC4x123m0(p1,p2,p3,p4,za,zb)
      implicit none
      include 'src/Inc/types.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/sprods_com.f'
      include 'src/Inc/zprods_decl.f'
      integer p1,p2,p3,p4
      real(dp):: s12,s13,s14,s23,s24,s34,s123,s14p24p34,Delta
      complex(dp):: aqmmC4x123m0,zab2
 
      zab2(p1,p2,p3,p4)=za(p1,p2)*zb(p2,p4)+za(p1,p3)*zb(p3,p4)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
                          
      s123=s12+s13+s23
      s14p24p34=s14+s24+s34
      Delta=(s13+s23)*(s14+s24)-s12*s34

      aqmmC4x123m0=
     & -2*zab2(p4,p2,p3,p1)**2*zab2(p4,p1,p3,p2)
     & /(zb(p1,p2)*zb(p2,p3)*zab2(p4,p1,p2,p3)*s123) 
     & -za(p2,p3)*za(p2,p4)*za(p3,p4)*zb(p3,p4)*s14p24p34
     & /(za(p1,p2)*zb(p3,p4)*Delta)
     & -zb(p1,p3)*zb(p1,p4)*za(p3,p4)**2*s14p24p34
     & /(zb(p1,p2)*zb(p3,p4)*Delta)
     & +za(p2,p3)**2*s14p24p34
     & /(za(p1,p2)*zb(p3,p4)*zab2(p3,p1,p2,p4))
     & +za(p2,p4)**2*s14p24p34
     & /(za(p1,p2)*zb(p3,p4)*zab2(p4,p1,p2,p3))
     & +2*zb(p1,p3)*zb(p1,p4)*s14p24p34
     & /(zb(p1,p2)*zb(p3,p4)**3)
      return
      end


      function aqmmC4x123m2(p1,p2,p3,p4,za,zb)
      implicit none
      include 'src/Inc/types.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/sprods_com.f'
      include 'src/Inc/zprods_decl.f'
      integer p1,p2,p3,p4
      real(dp):: s12,s13,s14,s23,s24,s34,s123,s14p24p34,Delta
      complex(dp):: aqmmC4x123m2,zab2
 
      zab2(p1,p2,p3,p4)=za(p1,p2)*zb(p2,p4)+za(p1,p3)*zb(p3,p4)

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      s123=s12+s13+s23
      s14p24p34=s14+s24+s34
      Delta=(s13+s23)*(s14+s24)-s12*s34

      aqmmC4x123m2=
     & 8*zab2(p4,p2,p3,p1)**2*zab2(p4,p1,p3,p2)
     & /(zb(p1,p2)*zb(p2,p3)*zab2(p4,p1,p2,p3)*s14p24p34*s123) 
     & -4*zb(p1,p3)*zb(p1,p4)*za(p3,p4)*s14p24p34
     & /(zb(p1,p2)*zb(p3,p4)**2*Delta) 
     & -4*za(p2,p3)*za(p2,p4)*s14p24p34
     & /(za(p1,p2)*zb(p3,p4)*Delta)
      return
      end
