!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      function aqmpC3x412(p1,p2,p3,p4,za,zb)
      implicit none
      include 'src/Inc/types.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/zprods_decl.f'
      include 'src/ggHgg_mass/mtsq.f'
      integer p1,p2,p3,p4
      complex(dp):: aqmpC3x412,aqmpC3x412m0,aqmpC3x412m2
      aqmpC3x412=aqmpC3x412m0(p1,p2,p3,p4,za,zb)
     &     +mtsq*aqmpC3x412m2(p1,p2,p3,p4,za,zb)
      return
      end

      function aqmpC3x412m0(p1,p2,p3,p4,za,zb)
      implicit none
      include 'src/Inc/types.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/zprods_decl.f'
      include 'src/Inc/sprods_com.f'
      integer p1,p2,p3,p4
      real(dp)::s124,s13p23p34
      complex(dp):: aqmpC3x412m0,zab2

      zab2(p1,p2,p3,p4)=za(p1,p2)*zb(p2,p4)+za(p1,p3)*zb(p3,p4)
                          
      s124=s(p1,p2)+s(p1,p4)+s(p2,p4)
      s13p23p34=s(p2,p3)+s(p1,p3)+s(p4,p3)                                                                             
                                                         
      aqmpC3x412m0 = 
     & (+2*zb(p4,p3)*zab2(p3,p2,p4,p1)**2*s124)
     & /(zb(p2,p1)*zab2(p3,p1,p2,p4)**3)
     &  +(-2*zb(p1,p3)*zab2(p3,p2,p4,p1)*s124)
     & /(zb(p2,p1)*zab2(p3,p1,p2,p4)**2)
     &  +(+zb(p1,p3)**2*zab2(p3,p2,p4,p1))
     & /(zb(p2,p1)*zb(p1,p4)*zab2(p3,p1,p2,p4))
     &  +(-za(p2,p4)**2*s13p23p34)
     & /(za(p2,p1)*za(p4,p3)*zab2(p3,p1,p2,p4)) +
     & (+zb(p1,p3)**3)/(zb(p2,p1)*zb(p1,p4)*zb(p4,p3))

                          
      return
      end

      function aqmpC3x412m2(p1,p2,p3,p4,za,zb)
      implicit none
      include 'src/Inc/types.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/zprods_decl.f'
      include 'src/Inc/sprods_com.f'
      integer p1,p2,p3,p4
      real(dp)::s13p23p34
      complex(dp):: aqmpC3x412m2,zab2

      zab2(p1,p2,p3,p4)=za(p1,p2)*zb(p2,p4)+za(p1,p3)*zb(p3,p4)
                          
      s13p23p34=s(p2,p3)+s(p1,p3)+s(p4,p3)                                                                             
      aqmpC3x412m2 =
     & +4*zb(p1,p4)*zb(p1,p3)*s13p23p34
     & /(zb(p2,p1)*zb(p4,p3)*zab2(p3,p1,p2,p4)**2)
     & +4*za(p2,p4)*za(p2,p3)*s13p23p34
     & /(za(p2,p1)*za(p4,p3)*zab2(p3,p1,p2,p4)**2)
     & -8*zb(p1,p3)**3/(zb(p2,p1)*zb(p1,p4)*zb(p4,p3)*s13p23p34)
      return
      end




