!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine haqaq_mass_tb(i1,i2,i3,i4,msq,idmsq)
! Matrix element squared for the procoess
!  0 -> H + a(i1) + q(i2) + a(i3) + q(i4)
! with full top mass dependence retained
! Note that the bottom quark is included with the pole mass in the propagator,
! and a running mass mb(mh) in the Yukawa coupling
      implicit none
      include 'src/Inc/types.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/constants.f'
      include 'src/Inc/zprods_com.f'
      include 'src/Inc/masses.f'
      include 'src/ggHgg_mass/mtsq.f'
      include 'src/Inc/ewcouple.f'
      include 'src/Inc/qcdcouple.f'
      integer i1,i2,i3,i4,h1,h2,iq
      real(dp):: msq,idmsq
      complex(dp) :: amp(2,2),idamp(2,2),
     & ampt(2,2),idampt(2,2),ampb(2,2),idampb(2,2)

      do iq=1,2
      
      if (iq == 1) then
        mtsq=mt**2
        call aqaqH(i1,i2,i3,i4,za,zb,ampt,idampt)
        ampt(:,:)=ampt(:,:)*mtsq
        idampt(:,:)=idampt(:,:)*mtsq
      endif
      if (iq == 2) then
        mtsq=mb**2
        call aqaqH(i1,i2,i3,i4,za,zb,ampb,idampb)
        ampb(:,:)=ampb(:,:)*mtsq
        idampb(:,:)=idampb(:,:)*mtsq
      endif
      
      enddo
      
      ampb(:,:)=ampb(:,:)*(3.38_dp/mb)       ! Hack for Yukawa with mb(mh)

      amp(:,:)=ampt(:,:)+ampb(:,:)
      idamp(:,:)=idampt(:,:)+idampb(:,:)

! Add helicities
      msq=zip
      idmsq=zip
      do h1=1,2
      do h2=1,2
      msq=msq+abs(amp(h1,h2))**2
      idmsq=idmsq+abs(amp(h1,h2))**2+abs(idamp(h1,h2))**2
      if (h1 == h2) idmsq=idmsq+real(2._dp*amp(h1,h2)*conjg(idamp(h1,h2)))/xn
      enddo
      enddo
      
! Apply overall factor
      msq=msq*V*(as**2)**2/vevsq
      idmsq=idmsq*V*(as**2)**2/vevsq

      return
      end

