!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      function ppmmD1x23x4(p1,p2,p3,p4,za,zb)
      implicit none
!     This is a calculation for the process 1_g^+ 2_g^+ 3_g^- 4_g^- +H
!     Implementation of Eq.~(7.8) from arXiv:2002.04018 v2
      include 'src/Inc/types.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/zprods_decl.f'
      include 'src/Inc/sprods_com.f'
      include 'src/ggHgg_mass/mtsq.f'
      include 'src/ggHgg_mass/Cred.f'
      include 'src/ggHgg_mass/I5to4.f'
      integer p1,p2,p3,p4
      real(dp):: s12,s34,C3
      complex(dp):: ppmmD1x23x4,zab2,e1x2x3x4,zab1234,zab4231
cc                        
      zab2(p1,p2,p3,p4)=za(p1,p2)*zb(p2,p4)+za(p1,p3)*zb(p3,p4)
                          
      s12=s(p1,p2)
      s34=s(p3,p4)
                          
      C3=Cred(3,I5to4(p1,p2,p3))

      e1x2x3x4=mtsq*(s12+s34-4._dp*mtsq)*zb(p1,p2)*za(p3,p4)
     & /(za(p1,p2)*zb(p3,p4))

      zab1234=zab2(p1,p2,p3,p4)
      zab4231=zab2(p4,p2,p3,p1)

      ppmmD1x23x4 = C3*e1x2x3x4
     & -0.5_dp*zab4231
     & *(zb(p2,p1)*zb(p2,p4)/(zb(p1,p4)*zb(p2,p3)*zb(p3,p4))
     & *(zb(p2,p1)-4*mtsq*zb(p2,p4)/zab1234)
     &  +za(p4,p3)*za(p1,p3)/(za(p2,p3)*za(p1,p4)*za(p1,p2))
     & *(za(p4,p3)-4*mtsq*za(p1,p3)/zab1234))

      return
      end
