!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      function ppmpC2x341m2(p1,p2,p3,p4,za,zb)
      implicit none
!     This is a calculation for the process 1_g^+ 2_g^+ 3_g^- 4_g^- +H
!     Implementation of Eq.~(5.27) from arXiv:2002.04018 v2
      include 'src/Inc/types.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/zprods_decl.f'
      include 'src/Inc/sprods_com.f'
      complex(dp)::ppmpC2x341m2
      integer p1,p2,p3,p4
      real(dp):: s12,s13,s14,s23,s24,s34,s134
      complex(dp)::zab2,zab1342,zab3142
      zab2(p1,p2,p3,p4)=za(p1,p2)*zb(p2,p4)+za(p1,p3)*zb(p3,p4)
                          
      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
       
      s134=s13+s14+s34                   
      zab1342=zab2(p1,p3,p4,p2)
      zab3142=zab2(p3,p1,p4,p2)                          
                                                                                                           
      ppmpC2x341m2 = -8._dp*zab2(p4,p1,p3,p2)**4/((s12+s23+s24)*s134)
     & /(za(p1,p4)*za(p3,p4)*zab1342*zab3142)

     & +4._dp*zb(p1,p2)*zb(p2,p3)*(s12+s23+s24)*s134
     & /(za(p1,p2)*zb(p1,p4)*za(p2,p3)*zb(p3,p4)
     & *zab1342*zab3142)

     & -4._dp*(s12+s23+s24)/(za(p1,p2)*((s13+s14)*(s23+s24)-s12*s34))
     &*(zb(p1,p2)*za(p1,p4)*za(p2,p4)**2/(za(p1,p2)*za(p2,p3)*za(p3,p4))
     & -zb(p1,p3)**2*zb(p2,p3)/(zb(p1,p4)*zb(p3,p4)))

     & -4._dp*(s12+s23+s24)/(za(p3,p2)*((s13+s34)*(s12+s24)-s23*s14))
     &*(zb(p3,p2)*za(p3,p4)*za(p2,p4)**2/(za(p3,p2)*za(p2,p1)*za(p1,p4))
     & -zb(p3,p1)**2*zb(p2,p1)/(zb(p3,p4)*zb(p1,p4)))

      return
      end
