!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      function pppmB1234(p1,p2,p3,p4,za,zb)
      implicit none
!     This is a calculation for the process 1_g^+ 2_g^+ 3_g^- 4_g^- +H
!     Implementation of Eq.~(5.32) from arXiv:2002.04018 v2
      include 'src/Inc/types.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/zprods_decl.f'
      complex(dp)::pppmB1234,pppmB34,pppmB341,pppmB234
      integer p1,p2,p3,p4

      pppmB1234=
     & -pppmB34(p1,p2,p3,p4,za,zb)
     & -pppmB34(p3,p2,p1,p4,za,zb)
     & -pppmB234(p1,p2,p3,p4,za,zb)
     & -pppmB341(p1,p2,p3,p4,za,zb)
     & -pppmB234(p3,p2,p1,p4,za,zb)
      return
      end
