!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      function pppmC1x234m2(p1,p2,p3,p4,za,zb)
      implicit none
!     This is a calculation for the process 1_g^+ 2_g^+ 3_g^+ 4_g^- +H
!     Implementation of Eq.~(5.25) from arXiv:2002.04018 v2
      include 'src/Inc/types.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/zprods_decl.f'
      include 'src/Inc/sprods_com.f'
      complex(dp)::pppmC1x234m2
      integer p1,p2,p3,p4
      real(dp)::s12,s13,s14,s23,s24,s34,s234,s12p13p14
      complex(dp):: zab2,zab1234,zab4231,zab2341,zab1342
C---- statement function      
      zab2(p1,p2,p3,p4)=za(p1,p2)*zb(p2,p4)+za(p1,p3)*zb(p3,p4)
C---- end statement function      
      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      s234=s23+s24+s34
      s12p13p14=s12+s13+s14
      zab1234=zab2(p1,p2,p3,p4)
      zab4231=zab2(p4,p2,p3,p1)
      zab2341=zab2(p2,p3,p4,p1)
      zab1342=zab2(p1,p3,p4,p2)

      pppmC1x234m2=
     & +8._dp*zab4231**3/(s234*s12p13p14
     & *za(p2,p3)*za(p3,p4)*zab2341)
!
     & -4._dp*s12p13p14/(za(p1,p2)*za(p3,p4))
     & *(za(p1,p4)**2*zb(p2,p3)/(za(p1,p2)*zab1342*zab1234)
!
     & -zb(p2,p3)/(zab1234*zab1342*zab2341)
     & *(za(p1,p2)*zb(p1,p3)*zb(p2,p3)*za(p3,p4)/zb(p3,p4)
     &  +zb(p1,p2)*za(p1,p4)*za(p2,p4))
!
     & -(zb(p1,p3)*za(p1,p4)*za(p2,p4)/za(p1,p2)
     &  +za(p2,p4)*zab4231/za(p2,p3))
     & /(zab1234*zab2341))

      return
      end

