!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      function pppmD4x3x21(p1,p2,p3,p4,za,zb)
      implicit none
!     This is a calculation for the process 1_g^+ 2_g^+ 3_g^+ 4_g^- +H
!     Implementation of Eq.~(5.14) from arXiv:2002.04018 v2
      include 'src/Inc/types.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/zprods_decl.f'
      include 'src/Inc/sprods_com.f'
      include 'src/ggHgg_mass/mtsq.f'
      include 'src/ggHgg_mass/Cred.f'
      include 'src/ggHgg_mass/I5to4.f'
      integer p1,p2,p3,p4
      real(dp):: s34,s123
      complex(dp):: pppmD4x3x21,zab2,e1x2x3x4

      zab2(p1,p2,p3,p4)=za(p1,p2)*zb(p2,p4)+za(p1,p3)*zb(p3,p4)

      s34=s(p3,p4)
      s123=s(p1,p2)+s(p1,p3)+s(p2,p3)
      e1x2x3x4=(s123-4._dp*mtsq)*mtsq
     & *zab2(p4,p2,p3,p1)/zab2(p1,p2,p3,p4)*zb(p2,p3)/za(p2,p3)

      pppmD4x3x21=(4._dp*mtsq-s123)*(
     & +0.5_dp*s34*s123**2
     & /(za(p1,p2)*za(p2,p3)*zab2(p1,p2,p3,p4)*zab2(p3,p1,p2,p4)))
     & +e1x2x3x4*Cred(2,I5to4(p1,p2,p3))

      return
      end

