!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      function ppppC1x234(p1,p2,p3,p4,za,zb,Coeffmsq)
      implicit none
!     This is a calculation for the process 1_g^+ 2_g^+ 3_g^+ 4_g^+ +H
      include 'src/Inc/types.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/zprods_decl.f'
      include 'src/ggHgg_mass/mtsq.f'
      complex(dp)::ppppC1x234m0,ppppC1x234m2,ppppC1x234,Coeffmsq
      integer p1,p2,p3,p4
      Coeffmsq=ppppC1x234m2(p1,p2,p3,p4,za,zb)
      ppppC1x234=ppppC1x234m0(p1,p2,p3,p4,za,zb)+mtsq*Coeffmsq
      return
      end

      function ppppC1x234m0(p1,p2,p3,p4,za,zb)
      implicit none
!     This is a calculation for the process 1_g^+ 2_g^+ 3_g^+ 4_g^+ +H
!     Implementation of Eq.~(4.9) from arXiv:2002.04018 v2
      include 'src/Inc/types.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/zprods_decl.f'
      include 'src/Inc/sprods_com.f'
      complex(dp)::ppppC1x234m0
      integer::p1,p2,p3,p4
      real(dp)::s12,s13,s14,s23,s24,s34,s1234
      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      s1234=s12+s13+s14+s23+s24+s34
      ppppC1x234m0=-(s12+s13+s14)
     & *s1234/(za(p1,p2)*za(p2,p3)*za(p3,p4)*za(p4,p1)) 
      return
      end


